#only  task-specific loss
# only reference citation paper 160897,train citation paper 1562139,
# train paper 1562139,test paper 33644, only reference paper 160897, whole paper 1756680
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse
import input_tripledata
import PRJF1metric1
import function_score

datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../EmbeddingGraph/TaskEmbedGraph/'
#datafile2 = '../EmbeddingGraph/GeneralEmbedGraph/'
#datafile2 = '../EmbeddingGraph/CombineEmbedGraph/'
NUmtestP=162
#NUmtestP=33644
#obtain the testPindex2id
inf1 = open(datafile1+"DM_test_paper.txt","r")
testP2id=dict()
id2testP=dict()
for line in inf1.readlines():
	t2=line.strip().split('	')
	testP2id[t2[1]]=int(t2[0])
	id2testP[t2[0]]=t2[1]
# obtain author2id dict
author2id=dict()
tfile4 = open(datafile1+'DM_author.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	author2id[t2[1]]=int(t2[0])
tfile4.close()
print '------------------get the testP_100candAuthor_dict and testP_100candAuthorid_dict-------------'
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(int(t2[1]))
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(author2id[t2[1]])
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()

author_emb=np.loadtxt(datafile2+"author_embedresult.txt")
testP_emb=np.loadtxt(datafile2+"testP_embedresult.txt")

testPAmat=np.dot(testP_emb,author_emb.transpose())
print testPAmat.shape
#AAmat=np.dot(author_emb,author_emb.transpose())
t11=time.time()
for ii in range(0,NUmtestP):
	paperid=str(ii)
	tempe=id2testP[paperid]
	tempAlist=testP_100candAuthorid_dict[tempe]
	tempAembed=author_emb[tempAlist,:]
	testPmat=testPAmat[ii,tempAlist]
	#testPmat=np.dot(testP_emb[ii,:],tempAembed.transpose())
	testPmatMaxNorm=preprocessing.normalize(testPmat,norm='max')
	r=testPmatMaxNorm>0
	ind=np.where(r)
	print 'the th test paper:'+paperid
	AAmat100=np.dot(tempAembed,tempAembed.transpose())
	#AAmat100=AAmat[tempAlist,:][:,tempAlist]
	AAmat100RowMax=preprocessing.normalize(AAmat100,norm='max')
	#print AAmat100RowMax.shape
	#print AAmat100RowMax
	testPAindex=testP_100candAuthor_dict[tempe]
	# write the P----A part of graph
	outfile1 = open(datafile2+"100candA_GraphTestPid"+paperid+".txt","w")
	for i in range(0,len(ind[1])):
		outfile1.write(tempe+'	'+str(testP_100candAuthor_dict[tempe][ind[1][i]])+'	'+str(testPmatMaxNorm[0,ind[1][i]])+'\n')
	# write the A----A part of graph
	#print AAmat100RowMax[0,:].shape
	#print AAmat100RowMax[:,0].shape
	#print AAmat100RowMax[0,:]
	#print AAmat100RowMax[:,0]
	for j in range(0,100):
		#rtemp=AAmat100RowMax[j,j:100]>np.mean(AAmat100RowMax[j,:])
		rtemp=AAmat100RowMax[j,j:100]>0
		#print rtemp.shape
		#print (rtemp.reshape(1,-1)).shape
		rrtemp=rtemp.reshape(1,-1)
		indtt=np.where(rrtemp)
		#print indtt
		#print indtt[1]
		for ji in range(0,len(indtt[1])):
			outfile1.write(str(testPAindex[j])+'	'+str(testPAindex[indtt[1][ji]+j])+'	'+str(AAmat100RowMax[j,indtt[1][ji]+j])+'\n')
t22=time.time()
print 'get whole embedding big graph time:'+str(t22-t11)
