import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse

import PRJF1metric

datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../100candMDSubgraph/'
#NUmtestP=1
NUmtestP=162
#NUmtestP=1000 #  all 16401 test papers author num in [3,5]

#infile2 = open(datafile1+'testPid_Pindex_authornum35.txt','r')
infile2 = open(datafile1+'DM_test_paper.txt','r')
testP35=dict()
testP35idlist=list()
for line in infile2.readlines():
	t2=line.strip().split('	')
	testP35[t2[0]]=t2[1]
	testP35idlist.append(t2[0])
print len(testP35)
print len(testP35idlist)

# obtain author2id dict
author2id=dict()
tfile4 = open(datafile1+'DM_author.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	author2id[t2[1]]=int(t2[0])
tfile4.close()
# obtain id2testP dict
id2testP=dict()
tfile4 = open(datafile1+'DM_test_paper.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	id2testP[int(t2[0])]=t2[1]
tfile4.close()

print '------------------get the testP_100candAuthor_dict and testP_100candAuthorid_dict-------------'
testP_predA100_dict=dict()# predA100 is the top10 decrease order of 100 candidate authors
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(t2[1])
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(author2id[t2[1]])
	if t2[0] not in testP_predA100_dict:
		testP_predA100_dict[t2[0]]=list()
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()

#obtain the PTPA matrix
tfile1 = open(datafile1+'testPT3tuple.txt')
data1 = np.loadtxt(tfile1,delimiter='	')
row1=data1[:,0]
col1=data1[:,1]
d1=data1[:,2]
testPT=spy.sparse.csr_matrix((d1,(row1,col1)),shape=(162,12467))
testPTRowNorm=preprocessing.normalize(testPT,norm='l1')


tfile = open(datafile1+'TtrainP3tuple.txt')
data = np.loadtxt(tfile,delimiter='	')
row=data[:,0]
print max(row)
col=data[:,1]
print max(col)
d=data[:,2]
TtrainP=spy.sparse.csr_matrix((d,(row,col)),shape=(12467,8659))
#AT=A.transpose()
# normalize according to the row
TtrainPRowNorm=preprocessing.normalize(TtrainP,norm='l1') 


tfile2 = open(datafile1+'trainPA3tuple.txt')
data2 = np.loadtxt(tfile2,delimiter='	')
row=data2[:,0]
col=data2[:,1]
d=data2[:,2]
trainPA=spy.sparse.csr_matrix((d,(row,col)),shape=(8659,12660))
trainPARowNorm=preprocessing.normalize(trainPA,norm='l1')

print 'get the matrix of PTPA'
# resultdata means the final PTPA similarity matrix
#resultdatatemp=np.dot(testPT,TtrainP) #pathcount
#resultdata=np.dot(resultdatatemp,trainPA) #pathcount
resultdatatemp=np.dot(testPTRowNorm,TtrainPRowNorm) #pcrw
resultdata=np.dot(resultdatatemp,trainPARowNorm) #pcrw
# sort according to row
#resulindex=np.argsort(-resultdata.todense(),axis=1)
sizenum=resultdata.shape 
print 'the number of row , column of matrix PTPA'
print sizenum[0]
print sizenum[1]

print 'get the matrix of APA'
#get the matrix of APA
AtrainP=trainPA.transpose()
AtrainPRowNorm=preprocessing.normalize(AtrainP,norm='l1')
#APAresultdata=np.dot(AtrainP,trainPA) #pathcount
APAresultdata=np.dot(AtrainPRowNorm,trainPARowNorm) #pcrw
sizenumber=APAresultdata.shape
print 'the number of row , column of matrix APA'
print sizenumber[0]
print sizenumber[1]

#obtain the APTPA matrix, using APTPA instead of APA in whole graph
'''
print 'get the matrix of APTPA'
AtrainP=trainPA.transpose()
AtrainPRowNorm=preprocessing.normalize(AtrainP,norm='l1')
tfile34 = open(datafile1+'trainPtrainT3tuple.txt')
data34 = np.loadtxt(tfile34,delimiter='	')
row34=data34[:,0]
col34=data34[:,1]
d34=data34[:,2]
trainPtrainT=spy.sparse.csr_matrix((d34,(row34,col34)),shape=(1562139,402687))
trainPtrainTRowNorm=preprocessing.normalize(trainPtrainT,norm='l1')
trainTtrainP=trainPtrainT.transpose()
trainTtrainPRowNorm=preprocessing.normalize(trainTtrainP,norm='l1')

#resultdatatemp=np.dot(AtrainP,trainPtrainT) #pathcount
#resultdatatemptt=np.dot(resultdatatemp,trainTtrainP) #pathcount
#APAresultdata=np.dot(resultdatatemptt,trainPA) #pathcount

resultdatatemp=np.dot(AtrainPRowNorm,trainPtrainTRowNorm) #pcrw
resultdatatemptt=np.dot(resultdatatemp,trainTtrainPRowNorm) #pcrw
APAresultdata=np.dot(resultdatatemptt,trainPARowNorm) #pcrw
sizenumber=APAresultdata.shape
print 'the number of row , column of matrix APTPA'
print sizenumber[0]
print sizenumber[1]
'''
t1=time.time()
for ii in range(0,NUmtestP):
#for ii in range(241,242):
	#obtain PTPA 100andAuthor ,P100candA_dict: key:100candAuthor, value:similarity
	P100candA_dict=dict()
	testPid=testP35idlist[ii]
	testPindex=testP35[testPid]
	#resultdata[int(testPid),testP_100candAuthorid_dict[testPindex]]
	matrixtemp=preprocessing.normalize(resultdata[int(testPid),testP_100candAuthorid_dict[testPindex]],norm='max').todense()
	tempt=matrixtemp>0
	ind=np.where(tempt)
	#print len(ind[1])
	for i in range(0,len(ind[1])):
		indt=ind[1][i]
		P100candA_dict[testP_100candAuthor_dict[testPindex][indt]]=matrixtemp[0,indt]
	#print 'finish P100candA_dict,that is the 100candidate authors and similarities'
	# obtain the APA part of graphPTPA_APA 100andAuthor
	outfile0 = open(datafile2+"100candA_GraphTestPid"+testP35[testP35idlist[ii]]+".txt","w")
	#outfile0 = open("100candA_APTPAGraphTestPid"+testP35[testP35idlist[ii]]+".txt","w")
	for j in range(0,100):
		matrixtempt=preprocessing.normalize(APAresultdata[testP_100candAuthorid_dict[testPindex][j],testP_100candAuthorid_dict[testPindex]],norm='max').todense()
		#rtemp=matrixtempt[0,j:100]>np.mean(matrixtempt[0,:])
		rtemp=matrixtempt[0,j:100]>0
		indtt=np.where(rtemp)
		#print len(indtt[1])
		for ji in range(0,len(indtt[1])):
			outfile0.write(testP_100candAuthor_dict[testPindex][j]+'	'+testP_100candAuthor_dict[testPindex][indtt[1][ji]+j]+'	'+str(matrixtempt[0,indtt[1][ji]+j])+'\n')
	for jk in P100candA_dict:
		#print P100candA_dict[jk]
		#print type(P100candA_dict[jk])
		outfile0.write(testPindex+'	'+jk+'	'+str(float(P100candA_dict[jk]))+'\n')
	if len(P100candA_dict)==0:
		for jkm in range(0,100):
			outfile0.write(testPindex+'	'+testP_100candAuthor_dict[testPindex][jkm]+'	'+str(1)+'\n')
	print 'the th test paper:'+str(ii)

	
t2=time.time()
print 'get whole big graph time:'+str(t2-t1)
