import scipy as spy
from scipy import sparse
import numpy as np
from sklearn import preprocessing
import time
import PRJF1metric

t1=time.time()
datafile = '../../../DBLP_v8/'
tfile1 = open('../testPV3tuple.txt')
data1 = np.loadtxt(tfile1,delimiter='	')
row1=data1[:,0]
col1=data1[:,1]
d1=data1[:,2]
testPT=spy.sparse.csr_matrix((d1,(row1,col1)),shape=(162,5))
testPTRowNorm=preprocessing.normalize(testPT,norm='l1')


tfile = open('../VtrainP3tuple.txt')
data = np.loadtxt(tfile,delimiter='	')
row=data[:,0]
print max(row)
col=data[:,1]
print max(col)
d=data[:,2]
TtrainP=spy.sparse.csr_matrix((d,(row,col)),shape=(5,8659))
#AT=A.transpose()
# normalize according to the row
TtrainPRowNorm=preprocessing.normalize(TtrainP,norm='l1') 


tfile2 = open('../trainPA3tuple.txt')
data2 = np.loadtxt(tfile2,delimiter='	')
row=data2[:,0]
col=data2[:,1]
d=data2[:,2]
trainPA=spy.sparse.csr_matrix((d,(row,col)),shape=(8659,12660))
trainPARowNorm=preprocessing.normalize(trainPA,norm='l1')

print 'get the matrix of PTPA'
# resultdata means the final PTPA similarity matrix
#resultdatatemp=np.dot(testPT,TtrainP) #pathcount
#resultdata=np.dot(resultdatatemp,trainPA) #pathcount
resultdatatemp=np.dot(testPTRowNorm,TtrainPRowNorm) #pcrw
resultdata=np.dot(resultdatatemp,trainPARowNorm) #pcrw
# sort according to row
#resulindex=np.argsort(-resultdata.todense(),axis=1)
sizenum=resultdata.shape 
print 'the number of row , column of matrix PTPA'
print sizenum[0]
print sizenum[1]


# obtain id2author array
tfile3 = open('../DM_author.txt')
authorindex = np.loadtxt(tfile3,delimiter='	')
authorarray=authorindex[:,1]

# obtain id2testpaper array
tfile4 = open('../DM_test_paper.txt')
testpindex = np.loadtxt(tfile4,delimiter='	')
testparray=testpindex[:,1]


print '-------------get  testP_predA_dict---------------' 
testP_predA_dict=dict()
for i in range(0,sizenum[0]):
	testp=str(int(testparray[i]))
	testP_predA_dict[testp]=list()
	for j in range(0,10):
		resulindex=np.argmax(resultdata[i,:].todense(),axis=1)
		resultdata[i,int(resulindex)]=0
		testP_predA_dict[testp].append(str(int(authorarray[int(resulindex)])))
print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open('../DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
print '---------------get the metric value---------'
k=3
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA_dict,k)
k=5
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA_dict,k)
k=10
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA_dict,k)
t2=time.time()
print 'time :'+str(t2-t1)
#print B
#print B.todense()
#print np.multiply(A,A1)# using parse matrix means that matrix multiply
#print np.multiply(A.todense(),A1.todense())# using dense matrix means that element wise multiply 
#print (A.todense())*(A1.todense())  # matrix multiply 
