import time
import numpy as np
import math
def evalu(testP_trueA_dict,testP_predA_dict):
	t1=time.time()
	#obtain the Jaccard Precision Recall F1 value        
	J=list()
	P=list()
	R=list()
	F1=list()
	AP=list()
	RMSE=0.0
	for j in testP_predA_dict:
		predA_k=set(testP_predA_dict[j])
		RMSE=RMSE+pow(len(testP_predA_dict[j])-len(testP_trueA_dict[j]),2)
		#print predA_k
		trueA=set(testP_trueA_dict[j])
		#print trueA
		tm=float(len(predA_k & trueA))
		#print predA_k & trueA
		#print tm
		tn=len(predA_k | trueA)
		J.append(float(tm)/tn)
		if len(testP_predA_dict[j])==0:
			p=0
		else:p=tm/len(testP_predA_dict[j])
		P.append(p)
		r=tm/len(trueA)
		R.append(r)
		F1.append(round(2*p*r/(p+r+0.000001),6))
		s=0.0
		countt=0
		if len(testP_predA_dict[j])>=1:
			for i in range(1,len(testP_predA_dict[j])+1):
				if testP_predA_dict[j][i-1] in testP_trueA_dict[j]:
					countt=countt+1
					s=s+(len(set(testP_predA_dict[j][0:i])&trueA)/float(i))
					#print len(set(testP_predA_dict[j][0:i])&trueA)/float(i)			
			#AP.append(s/min(k,len(trueA)))
			if countt==0:
				AP.append(0)
			else:AP.append(s/countt)
		else:AP.append(0)
		#print s
		#print s/(tm+0.000001)
		#print s/(countt+0.000001)
	'''
	file=open('Result.txt','w')  
	file.write('J'+':'+str(J)+'\n');
	file.write('P'+':'+str(P)+'\n');
	file.write('R'+':'+str(R)+'\n');
	file.write('F1'+':'+str(F1)+'\n');
	file.write('AP'+':'+str(AP)+'\n');
	file.close() 
	'''
	RMSE=math.sqrt(RMSE/33644)
	print 'J P R F1 AP number for all the predicted papers:'+str(len(J))+','+str(len(R))+','+str(len(P))+','+str(len(F1))+','+str(len(AP))
	print 'max min mean var  value of J: ' +str(max(J))+','+str(min(J))+','+str(np.mean(J))+','+str(np.var(J))
	print 'max min mean var  value of P: '+str(max(P))+','+str(min(P))+','+str(np.mean(P))+','+str(np.var(P))
	print 'max min mean var  value of R: '+str(max(R))+','+str(min(R))+','+str(np.mean(R))+','+str(np.var(R))
	print 'max min mean var  value of F1: '+str(max(F1))+','+str(min(F1))+','+str(np.mean(F1))+','+str(np.var(F1))
	print 'max min mean var  value of AP: '+str(max(AP))+','+str(min(AP))+','+str(np.mean(AP))+','+str(np.var(AP))
	#print 'top-k is equal to '+str(k)
	print 'mean of P: '+str(np.mean(P))+'	R:'+str(np.mean(R))+'	J:'+str(np.mean(J))+'	F1:'+str(np.mean(F1))+'	MAP@K:'+str(np.mean(AP))
	print 'RMSE:'+str(RMSE)
	return np.mean(P),np.mean(R),np.mean(J),np.mean(F1),np.mean(AP),RMSE
	
	t2=time.time()
	print 'time :'+str(t2-t1)

