#only  task-specific loss   +   tune parameter with metric measures in test data
# only reference citation paper 160897,train citation paper 1562139,
# train paper 1562139,test paper 33644, only reference paper 160897, whole paper 1756680
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse
import input_tripledata
import PRJF1metric


datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../EmbeddingGraph/TaskEmbedGraph/'
#datafile2 = '../EmbeddingGraph/GeneralEmbedGraph/'
#datafile2 = '../EmbeddingGraph/CombineEmbedGraph/'

t0=time.time()

# (venue,word,year,reference)index2id(id:int)
ALLpaper2id=dict()
#inf1 = open(datafile1+"id2onlyreference.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	ALLpaper2id[t2[1]]=int(t2[0])+1562139
wordindex2id=dict()
inf1 = open(datafile1+"DM_word.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	wordindex2id[t2[1]]=int(t2[0])
#trainyear2id=dict()
#inf1 = open(datafile1+"id2train_year.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	trainyear2id[t2[1]]=int(t2[0])
trainvenue2id=dict()
inf1 = open(datafile1+"DM_venue.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainvenue2id[t2[1]]=int(t2[0])

inf1 = open(datafile1+"DM_trainpaper.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	ALLpaper2id[t2[1]]=int(t2[0])

#obtain authorid2index dictionary and 5 dictionary trainP2word,author,venue,year,citation
authorid2index=dict()
authorindex2id=dict()
inf1 = open(datafile1+"DM_author.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	authorid2index[t2[0]]=t2[1]
	authorindex2id[int(t2[1])]=int(t2[0])
author_n=len(authorid2index)
trainPid_wordindex={}
trainPid_venueindex={}
#trainPid_yearindex={}
#trainPid_allCitationPindex={}
trainPid_authorindex={}
authorid_coauthorindex={}
#trainPid_citationOnlyRefindex={}
inf1 = open(datafile1+"DM_trainP_wordindex.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainPid_wordindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_wordindex[t2[0]].append(wordindex2id[t2[i+1]])
inf2 = open(datafile1+"DM_trainP_venueindex.txt","r")
for line in inf2.readlines():
	t2=line.strip().split('	')
	trainPid_venueindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_venueindex[t2[0]].append(trainvenue2id[t2[i+1]])
#inf3 = open("trainPid_yearindex.txt","r")
#for line in inf3.readlines():
#	t2=line.strip().split('	')
#	trainPid_yearindex[t2[0]]=list()
#	if len(t2)>1:
#		for i in range(0,len(t2)-1):
#			trainPid_yearindex[t2[0]].append(trainyear2id[t2[i+1]])
#inf4 = open("trainPid_allCitationPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip().split('	')
##	trainPid_allCitationPindex[t2[0]]=list()
#	if len(t2)>1:
##		for i in range(0,len(t2)-1):
#			trainPid_allCitationPindex[t2[0]].append(ALLpaper2id[t2[i+1]])
inf5 = open(datafile1+"DM_trainP_authorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	trainPid_authorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_authorindex[t2[0]].append(t2[i+1])
inf5 = open(datafile1+"DM_authorid_coauthorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	authorid_coauthorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			authorid_coauthorindex[t2[0]].append(t2[i+1])


print len(trainPid_wordindex)
print len(trainPid_venueindex)
#print len(trainPid_yearindex)
#print len(trainPid_allCitationPindex)
print len(trainPid_authorindex)
#print len(trainPid_citationOnlyRefindex)
trainPid_wordid=[]#[['1	9	7'],['4	5	6'],[]]
trainPid_venueid=[]
#trainPid_yearid=[]
#trainPid_citationTrainPid=[]
trainPid_authorid=[]
#trainPid_citationOnlyRefid=[]
#trainPid_allCitationPid=[]
inf1 = open(datafile1+"DM_notrainP_wordid.txt","r")
for line in inf1.readlines():
	t2=line.strip()
	trainPid_wordid.append(t2)
inf2 = open(datafile1+"DM_notrainP_venueid.txt","r")
for line in inf2.readlines():
	t2=line.strip()
	trainPid_venueid.append(t2)
#inf3 = open(datafile1+"trainPid_yearid.txt","r")
#for line in inf3.readlines():
#	t2=line.strip()
#	trainPid_yearid.append(t2[2:])
#inf4 = open("trainPid_citationtrainPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip()
#	trainPid_citationTrainPid.append(t2[2:])
inf5 = open(datafile1+"DM_notrainP_authorid.txt","r")
for line in inf5.readlines():
	t2=line.strip()
	trainPid_authorid.append(t2)
#inf51 = open("trainPid_onlyreferenceid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_citationOnlyRefid.append(t2[2:])

#inf51 = open("trainPid_allCitationPid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_allCitationPid.append(t2[2:])
# the pre-data of sampling the negtive author according to author degree
author_paperlist=dict()
inf6 = open(datafile1+"DM_train_p2a.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] not in author_paperlist:
		author_paperlist[t2[1]]=list()
	author_paperlist[t2[1]].append(t2[0])
print len(author_paperlist)

# ..............................................information of test papers........................................
# obtain id2testP dict
id2testP=dict()
testP2id=dict()
testPid_wordid=dict()
testPid_venueid=dict()
testPid_citationid=dict()
tfile4 = open(datafile1+'DM_test_paper.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	id2testP[int(t2[0])]=t2[1]
	testP2id[t2[1]]=int(t2[0])
	testPid_wordid[int(t2[0])]=list()
	testPid_citationid[int(t2[0])]=list()
tfile4.close()
print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
print '------------------get the testP_100candAuthor_dict and testP_100candAuthorid_dict-------------'
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(int(t2[1]))
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(authorindex2id[int(t2[1])])
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()
print '------------------get the testP_100candAuthor_array and testP_100candAuthorid_array-------------'
testP_100candAuthor_array=spy.sparse.lil_matrix((162,100))
testP_100candAuthorid_array=spy.sparse.lil_matrix((162,100))
testP_orderAuthor10_array=spy.sparse.lil_matrix((162,10))
for i in range(0,162):
	testP_100candAuthor_array[i,:]=testP_100candAuthor_dict[id2testP[i]]
	testP_100candAuthorid_array[i,:]=testP_100candAuthorid_dict[id2testP[i]]
testP_100candAuthor_array=testP_100candAuthor_array.astype(int)
testP_100candAuthorid_array=testP_100candAuthorid_array.astype(int)
print testP_100candAuthor_array.shape
print testP_100candAuthorid_array.shape


print '------------------get the testP_wordid,-testP_venueid,testP_refenrenceid------------'
ALLpaper2id=dict()
#inf1 = open(datafile1+"id2onlyreference.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	ALLpaper2id[t2[1]]=int(t2[0])+1562139
inf1 = open(datafile1+"DM_trainpaper.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	ALLpaper2id[t2[1]]=int(t2[0])
wordindex2id=dict()
inf1 = open(datafile1+"DM_word.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	wordindex2id[t2[1]]=int(t2[0])
trainvenue2id=dict()
inf1 = open(datafile1+"DM_venue.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainvenue2id[t2[1]]=int(t2[0])
print len(ALLpaper2id)
print len(wordindex2id)
print len(trainvenue2id)

inf6 = open(datafile1+"DM_test_p2o_final.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] in wordindex2id:
		testPid_wordid[testP2id[t2[0]]].append(wordindex2id[t2[1]])
	if t2[1] in trainvenue2id:
		testPid_venueid[testP2id[t2[0]]]=trainvenue2id[t2[1]]
	if t2[1] in ALLpaper2id:
		testPid_citationid[testP2id[t2[0]]].append(ALLpaper2id[t2[1]])


multiauthor=dict()# author cishu == the num of author's paper
authornumsample=0
multiauthor0=dict()# author cishu == the num of author's paper'0.75
authornumsample0=0
for eachj in author_paperlist:
	for eachk in range(0,len(author_paperlist[eachj])):
		multiauthor[authornumsample]=eachj
		authornumsample=authornumsample+1
	for eachk0 in range(0,int(pow(len(author_paperlist[eachj]),0.75))):
		multiauthor0[authornumsample0]=eachj
		authornumsample0=authornumsample0+1
print authornumsample
print authornumsample0
# input arguments
parser = argparse.ArgumentParser(description='code of embedding method for only 100 candidate authors')
parser.add_argument('--candA_num',type = int, default = 100,help = 'max num of candidate authors for each test paper')
parser.add_argument('--testP_num',type = int, default = 162,help = 'max num of test papers')
#parser.add_argument('--onlyreference_num',type = int, default = 160897,help = 'max num of only reference papers')
parser.add_argument('--word_num',type = int, default = 12467,help = 'max num of words')
parser.add_argument('--venue_num',type = int, default =5,help = 'max num of venue')
#parser.add_argument('--year_num',type = int, default = 60,help = 'max num of train year')
parser.add_argument('--trainP_num',type = int, default = 8659,help = 'max num of train papers')
parser.add_argument('--embed_dim',type = int, default = 512,help = 'embed dimension of author,paper,venue,word,year')
#parser.add_argument('--window',type = int, default = 5,help = 'window size ')
parser.add_argument('--batch_size',type = int, default = 200,help = 'batch size of training ')
parser.add_argument('--learn_rate',type = float, default = 0.00001,help = 'learning rate ')
parser.add_argument('--train_iter_max',type = int, default = 50,help = 'max num of training iteration ')
parser.add_argument('--margin_distance',type = float, default = 2,help = 'margin distance of augmented component ')
parser.add_argument('--coe_reg',type = float, default = 10,help = 'coefficient of regularization of task or general-network component ')
#parser.add_argument('--trainP_RefP_num',type = int, default = 1723036,help = 'max num of train papers and only reference papers')
#parser.add_argument('--coe_tradeoff',type = float, default = 1,help = 'tradoff coefficient of task and general-network component ')
args = parser.parse_args()
print (args)
#parameters setting
candA_n=args.candA_num
testP_n=args.testP_num
trainP_n=args.trainP_num
embed_d=args.embed_dim
batch_s=args.batch_size
learn_r=args.learn_rate
iter_max=args.train_iter_max
margin_d=args.margin_distance
c_reg=args.coe_reg
word_n=args.word_num
#year_n=args.year_num
venue_n=args.venue_num
#onlyreference_n=args.onlyreference_num
#trainP_RefP_n=args.trainP_RefP_num
#c_tradeoff=args.coe_tradeoff
#data preparation
#tensor preparation
p_a_a=tf.placeholder(tf.int32,[None,3])
a_a_aAPA=tf.placeholder(tf.int32,[None,3])
author_embed = tf.Variable(tf.random_normal([author_n,embed_d],mean=0,stddev=0.01))
word_embed = tf.Variable(tf.random_normal([word_n,embed_d],mean=0,stddev=0.01))
#year_embed = tf.Variable(tf.random_normal([year_n,embed_d],mean=0,stddev=0.01))
venue_embed = tf.Variable(tf.random_normal([venue_n,embed_d],mean=0,stddev=0.01))
trainP_embed = tf.Variable(tf.random_normal([trainP_n,embed_d],mean=0,stddev=0.01))
#onlyreferenceP_embed = tf.Variable(tf.random_normal([onlyreference_n,embed_d],mean=0,stddev=0.01))
weight = tf.Variable(tf.random_normal([1,2],mean=0.5,stddev=0.1))# the order of weight :word,venue
#Mprojectpa=tf.Variable(tf.random_normal([embed_d,embed_d],mean=0,stddev=0.01))

#con=tf.constant(0.5,dtype=np.float32)
#SimPA=tf.constant(MatrixPA)
testP_emb=spy.sparse.lil_matrix((162,embed_d))
k=3
optP=0
optR=0
optJ=0
optF1=0
optMAP=0
optRMSE=10
optloss=100
Loss_task=[]
Loss_APA=[]
NegNum=2
batchapa=1.83
apa_batch_s=int(batch_s*batchapa)
for i in range(batch_s):
	paperid=p_a_a[i][0]

	word_idindex=tf.gather(trainPid_wordid,paperid)
	temp1=tf.string_split([word_idindex],delimiter='	')
	#tempv=tf.string_to_number(temp1.values[0],tf.float32)
	Nw=tf.reduce_mean(tf.gather(word_embed,tf.string_to_number(temp1.values,tf.int32)),0)

	venue_idindex=tf.gather(trainPid_venueid,paperid)
	temp1=tf.string_split([venue_idindex],delimiter='	')
	Nv=tf.gather(venue_embed,tf.string_to_number(temp1.values,tf.int32))

	#weight=preprocessing.normalize(weight,norm='max')
	p_e=weight[0,0]*Nw+weight[0,1]*Nv
	# p_e   *   project matrix
	#p_e = tf.reshape(p_e,[embed_d,1])
	#p_e=tf.matmul(Mprojectpa,p_e)
	#tf.assign(trainP_embed[paperid,:],p_e)
	a_e_pos = tf.gather(author_embed,p_a_a[i][1])
	# a_e  *   project matrix
	#a_e_pos = tf.reshape(a_e_pos,[embed_d,1])
	#a_e_pos = tf.matmul(Mprojectpa,a_e_pos)
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,p_a_a[i][2])
	#a_e_neg = tf.reshape(a_e_neg,[embed_d,1])
	#a_e_neg = tf.matmul(Mprojectpa,a_e_neg)
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_1=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(p_e,a_e_neg))-tf.reduce_sum(tf.multiply(p_e,a_e_pos)),tf.zeros([1,1]))
	hing_1=tf.maximum(margin_d-tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_neg),tf.subtract(p_e,a_e_neg)))+\
	tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_pos),tf.subtract(p_e,a_e_pos))),tf.zeros([1,1]))
	Loss_task.append(hing_1)
for i in range(apa_batch_s):
	a_e = tf.gather(author_embed,a_a_aAPA[i][0])
	a_e = tf.reshape(a_e,[1,embed_d])
	a_e_pos = tf.gather(author_embed,a_a_aAPA[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,a_a_aAPA[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_2=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(a_e,a_e_neg))-tf.reduce_sum(tf.multiply(a_e,a_e_pos)),tf.zeros([1,1]))
	hing_4=tf.maximum(margin_d-tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_neg),tf.subtract(a_e,a_e_neg)))+\
	tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_pos),tf.subtract(a_e,a_e_pos))),tf.zeros([1,1]))
	Loss_APA.append(hing_4)

#joint losss
t_v = tf.trainable_variables()
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed),tf.nn.l2_loss(trainP_embed)])
reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed),tf.nn.l2_loss(Mprojectpa)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(v) for v in t_v])

X=tf.concat((author_embed,word_embed),0)
X=tf.concat((X,venue_embed),0)
n_rows=tf.cast(tf.shape(X)[0],tf.float32)
X=X-(tf.reduce_mean(X,axis=0))
cov=tf.matmul(X,X,transpose_a=True)/n_rows
Loss_cov=tf.reduce_sum(tf.matrix_set_diag(cov,tf.zeros(embed_d,tf.float32)))

#joint_lossPA=tf.reduce_mean(Loss_task)+c_reg*reg_loss
difWapa={}
#Wapa=1000.0
Wapa=1.0
for each in range(1,2):
	#Wapa=Wapa*0.1
	#joint_loss=tf.reduce_mean(Loss_task)+Wapa*tf.reduce_mean(Loss_APA)+c_reg*reg_loss
	joint_loss=tf.reduce_mean(Loss_task)+Wapa*tf.reduce_mean(Loss_APA)+c_reg*Loss_cov
	#optimizer
	#optimizerPA = tf.train.AdamOptimizer(learning_rate=learn_r).minimize(joint_lossPA)
	optimizer = tf.train.AdamOptimizer(learning_rate=learn_r).minimize(joint_loss)

	#train model
	init = tf.global_variables_initializer()
	saver = tf.train.Saver()
	t1=time.time()
	#with tf.Session() as sess:
	with tf.Session(config = tf.ConfigProto(inter_op_parallelism_threads=2,intra_op_parallelism_threads = 2)) as sess:
	#with tf.Session(config = tf.ConfigProto(log_device_placement=True)) as sess:
		sess.run(init)
		#author_emb=sess.run(author_embed)
		#word_emb=sess.run(word_embed)
		#venue_emb=sess.run(venue_embed)
		#wei=sess.run(weight)
		#print author_emb
		#print word_emb
		#randomly sample negtive author
		p_a_a_batch=input_tripledata.p_author_author(authorid2index,trainPid_authorindex,author_n,trainP_n,authorindex2id,NegNum)
		#sample negtive author according to author degree
		#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample,multiauthor,authorindex2id,NegNum)
		#sample negtive author according to author degree'0.75
		#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample0,multiauthor0,authorindex2id,NegNum)
		a_a_aAPA_batch=input_tripledata.a_a_aAPA(authorid2index,authorid_coauthorindex,author_n,authorindex2id,NegNum)
		mini_batch_n=int(len(p_a_a_batch)/batch_s)
		print 'mini_batch_n:'+str(mini_batch_n)
		print len(p_a_a_batch)
		print len(a_a_aAPA_batch)
		for epoch in range(iter_max):
			print 'epoch:'+str(epoch)
			random.shuffle(p_a_a_batch)
			random.shuffle(a_a_aAPA_batch)
			'''
			for j in range(mini_batch_n):
				p_a_a_mini_batch = p_a_a_batch[j*batch_s:(j+1)*batch_s]
				feed_dict={p_a_a:p_a_a_mini_batch}
				_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
				#_, loss_v = sess.run([optimizerPA,joint_lossPA],feed_dict)
			p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-batch_s:len(p_a_a_batch)]
			feed_dict={p_a_a:p_a_a_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
			#_, loss_v = sess.run([optimizerPA,joint_lossPA],feed_dict)
			'''
			for j in range(mini_batch_n):
				p_a_a_mini_batch = p_a_a_batch[j*batch_s:(j+1)*batch_s]
				a_a_a_mini_batch = a_a_aAPA_batch[j*apa_batch_s:(j+1)*apa_batch_s]
				feed_dict={p_a_a:p_a_a_mini_batch,a_a_aAPA:a_a_a_mini_batch}
				_, loss_v = sess.run([optimizer,joint_loss],feed_dict)

			p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-batch_s:len(p_a_a_batch)]
			a_a_a_mini_batch = a_a_aAPA_batch[len(a_a_aAPA_batch)-apa_batch_s:len(a_a_aAPA_batch)]
			feed_dict={p_a_a:p_a_a_mini_batch,a_a_aAPA:a_a_a_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
			print loss_v
			'''
			tf.assign(author_embed,tf.clip_by_norm(author_embed,clip_norm,axes=[1]))
			tf.assign(word_embed,tf.clip_by_norm(word_embed,clip_norm,axes=[1]))
			tf.assign(venue_embed,tf.clip_by_norm(venue_embed,clip_norm,axes=[1]))
			'''
			author_emb=sess.run(author_embed)
			word_emb=sess.run(word_embed)
			venue_emb=sess.run(venue_embed)
			#trainP_emb=sess.run(trainP_embed)
			wei=sess.run(weight)
			
			#print wei
			#Mprojectpa_emb=sess.run(Mprojectpa)
			for i in range(0,162):
				wordmean=np.mean(word_emb[testPid_wordid[i],:],axis=0)
				venuemean=venue_emb[testPid_venueid[i],:]
				#venuemean=np.mean(venue_emb[testPid_venueid[i],:],axis=0)
				#refmean=np.mean(trainpRefp_emb[testPid_citationid[i],:],axis=0)

				testP_emb[i,:]=wei[0][0]*wordmean+wei[0][1]*venuemean
				#project matrix
				#tg=(wei[0][0]*wordmean+wei[0][1]*venuemean).transpose()
				#testP_emb[i,:]=(np.dot(Mprojectpa_emb,tg)).transpose()
			for i in range(0,162):
				l=testP_100candAuthorid_array[i,:].todense()
				aemb=author_emb[l.tolist()[0],:]
				pemb=testP_emb[i,:].transpose()
				#project matrix
				#for hu in range(aemb.shape[0]):
				#	aemb[hu,:]=(np.dot(Mprojectpa_emb,aemb[hu,:].transpose())).transpose()
				# PRODUCTION DOT
				#aPmultiply=np.dot(aemb,pemb.todense())
				#Euclidean distance
				temarry=np.square(aemb-np.tile(testP_emb[i,:].todense(),[aemb.shape[0],1]))
				aPmultiply=np.sqrt(temarry.sum(axis=1))
				tem=(aPmultiply.transpose()).argsort()
				testP_orderAuthor10_array[i,:]=testP_100candAuthor_array[i,tem.tolist()[0][0:10]].todense()

			testP_orderAuthor10_dict={}# the top10 decrease order of 100 candidate authors
			for i in range(0,162):
				#print testP_orderAuthor10_array[i,:].todense().astype(np.int32).tolist()[0]
				#print map(str,testP_orderAuthor10_array[i,:].todense().astype(np.int32).tolist()[0])
				testP_orderAuthor10_dict[id2testP[i]]=map(str,testP_orderAuthor10_array[i,:].todense().astype(np.int32).tolist()[0])
			#np.savetxt(datafile2+"testP_embedresult.txt",testP_emb.todense())
		
			print '---------------get the metric value---------'
		
			evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_orderAuthor10_dict,k)
			#if evaluresul[0]>optP:
			#if evaluresul[1]>optR:
			#if evaluresul[2]>optJ:
			if evaluresul[3]>optF1:
			#if evaluresul[4]>optMAP:
			#if evaluresul[5]<optRMSE:
				optP=evaluresul[0]
				optR=evaluresul[1]
				optJ=evaluresul[2]
				optF1=evaluresul[3]
				optMAP=evaluresul[4]
				optRMSE=evaluresul[5]
				print 'the current optimal Precision value is :'+str(optP)
				'''
				opt_author_embed=author_embed
				opt_word_embed=word_embed
				opt_venue_embed=venue_embed
				opt_trainP_embed=trainP_embed
				opt_weight=weight
			
				opt_author_embed=sess.run(author_embed)
				opt_word_embed=sess.run(word_embed)
				opt_venue_embed=sess.run(venue_embed)
				opt_trainP_embed=sess.run(trainP_embed)
				opt_weight=sess.run(weight)
				'''
		print 'the optimal P,R,F1,J,MAP:'+str(optP)+', '+str(optR)+', '+str(optF1)+','+str(optJ)+','+str(optMAP)+','+str(optRMSE)
	difWapa[Wapa]=list()
	difWapa[Wapa].append(optP)
	difWapa[Wapa].append(optR)
	difWapa[Wapa].append(optF1)
	difWapa[Wapa].append(optJ)
	difWapa[Wapa].append(optMAP)
	difWapa[Wapa].append(optRMSE)
t9=time.time()
#print 'time of pre-data procession:'+str(t1-t0)
print 'time of iter 1 time :'+str(t9-t1)
print 'different weight  of relation APA, the result:'
print difWapa
