#only  task-specific loss   +   tune parameter with metric measures in test data
# only reference citation paper 160897,train citation paper 1562139,
# train paper 1562139,test paper 33644, only reference paper 160897, whole paper 1756680
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse
import input_tripledata
import PRJF1metric1
import function_score


datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../EmbeddingGraph/TaskEmbedGraph/'
#datafile2 = '../EmbeddingGraph/GeneralEmbedGraph/'
#datafile2 = '../EmbeddingGraph/CombineEmbedGraph/'

t0=time.time()
NegNum=1
#alphalist=[0.01,0.05,0.1,0.5,1.0]
alphalist=[0.01]
betalist=[0.1,0.5,1.0,5.0,10.0]
beta=betalist[0]
optscore=0
#Tmax=50
Tmax=20
NUmtestP=162 # 1 test paper
#NUmtestP=33644
PredAuthDict=dict()
weigAPWAPC=[0.5]
#weigAPWAPC=[0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0]
difomega={}
DMapcpa_authorid_authorid={}
DMapwpa_authorid_authorid={}
inf5 = open(datafile1+"DMapcpa_authorid_authorid.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	DMapcpa_authorid_authorid[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			DMapcpa_authorid_authorid[t2[0]].append(t2[i+1])
inf5 = open(datafile1+"DMapwpa_authorid_authorid.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	DMapwpa_authorid_authorid[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			DMapwpa_authorid_authorid[t2[0]].append(t2[i+1])

# (venue,word,year,reference)index2id(id:int)
ALLpaper2id=dict()
#inf1 = open(datafile1+"id2onlyreference.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	ALLpaper2id[t2[1]]=int(t2[0])+1562139
wordindex2id=dict()
wordid2index={}
inf1 = open(datafile1+"DM_word.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	wordindex2id[t2[1]]=int(t2[0])
	wordid2index[t2[0]]=t2[1]
#trainyear2id=dict()
#inf1 = open(datafile1+"id2train_year.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	trainyear2id[t2[1]]=int(t2[0])
trainvenue2id=dict()
trainvenueid2index={}
inf1 = open(datafile1+"DM_venue.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainvenue2id[t2[1]]=int(t2[0])
	trainvenueid2index[t2[0]]=t2[1]

inf1 = open(datafile1+"DM_trainpaper.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	ALLpaper2id[t2[1]]=int(t2[0])

#obtain authorid2index dictionary and 5 dictionary trainP2word,author,venue,year,citation
authorid2index=dict()
authorindex2id=dict()
author2id=dict()
inf1 = open(datafile1+"DM_author.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	authorid2index[t2[0]]=t2[1]
	authorindex2id[int(t2[1])]=int(t2[0])
	author2id[t2[1]]=int(t2[0])
author_n=len(authorid2index)
trainPid_wordindex={}
trainPid_venueindex={}
#trainPid_yearindex={}
#trainPid_allCitationPindex={}
trainPid_authorindex={}
authorid_coauthorindex={}
#trainPid_citationOnlyRefindex={}
inf1 = open(datafile1+"DM_trainP_wordindex.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainPid_wordindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			#trainPid_wordindex[t2[0]].append(wordindex2id[t2[i+1]])
			trainPid_wordindex[t2[0]].append(t2[i+1])
inf2 = open(datafile1+"DM_trainP_venueindex.txt","r")
for line in inf2.readlines():
	t2=line.strip().split('	')
	trainPid_venueindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			#trainPid_venueindex[t2[0]].append(trainvenue2id[t2[i+1]])
			trainPid_venueindex[t2[0]].append(t2[i+1])
#inf3 = open("trainPid_yearindex.txt","r")
#for line in inf3.readlines():
#	t2=line.strip().split('	')
#	trainPid_yearindex[t2[0]]=list()
#	if len(t2)>1:
#		for i in range(0,len(t2)-1):
#			trainPid_yearindex[t2[0]].append(trainyear2id[t2[i+1]])
#inf4 = open("trainPid_allCitationPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip().split('	')
##	trainPid_allCitationPindex[t2[0]]=list()
#	if len(t2)>1:
##		for i in range(0,len(t2)-1):
#			trainPid_allCitationPindex[t2[0]].append(ALLpaper2id[t2[i+1]])
inf5 = open(datafile1+"DM_trainP_authorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	trainPid_authorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_authorindex[t2[0]].append(t2[i+1])
inf5 = open(datafile1+"DM_authorid_coauthorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	authorid_coauthorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			authorid_coauthorindex[t2[0]].append(t2[i+1])

print len(trainPid_wordindex)
print len(trainPid_venueindex)
#print len(trainPid_yearindex)
#print len(trainPid_allCitationPindex)
print len(trainPid_authorindex)
#print len(trainPid_citationOnlyRefindex)
trainPid_wordid=[]#[['1	9	7'],['4	5	6'],[]]
trainPid_venueid=[]
trainPid_refid=[]
#trainPid_yearid=[]
#trainPid_citationTrainPid=[]
trainPid_authorid=[]
#trainPid_citationOnlyRefid=[]
#trainPid_allCitationPid=[]
inf1 = open(datafile1+"DM_notrainP_wordid.txt","r")
for line in inf1.readlines():
	t2=line.strip()
	trainPid_wordid.append(t2)
inf2 = open(datafile1+"DM_notrainP_venueid.txt","r")
for line in inf2.readlines():
	t2=line.strip()
	trainPid_venueid.append(t2)
inf1 = open(datafile1+"DM_notrainP_refid.txt","r")
for line in inf1.readlines():
	t2=line.strip()
	trainPid_refid.append(t2)
#inf3 = open(datafile1+"trainPid_yearid.txt","r")
#for line in inf3.readlines():
#	t2=line.strip()
#	trainPid_yearid.append(t2[2:])
#inf4 = open("trainPid_citationtrainPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip()
#	trainPid_citationTrainPid.append(t2[2:])
inf5 = open(datafile1+"DM_notrainP_authorid.txt","r")
for line in inf5.readlines():
	t2=line.strip()
	trainPid_authorid.append(t2)
#inf51 = open("trainPid_onlyreferenceid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_citationOnlyRefid.append(t2[2:])

#inf51 = open("trainPid_allCitationPid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_allCitationPid.append(t2[2:])
# the pre-data of sampling the negtive author according to author degree
author_paperlist=dict()
inf6 = open(datafile1+"DM_train_p2a.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] not in author_paperlist:
		author_paperlist[t2[1]]=list()
	author_paperlist[t2[1]].append(t2[0])
print len(author_paperlist)
#obtain the PTPA matrix
tfile1 = open(datafile1+'testPT3tuple.txt')
data1 = np.loadtxt(tfile1,delimiter='	')
row1=data1[:,0]
col1=data1[:,1]
d1=data1[:,2]
testPT=spy.sparse.csr_matrix((d1,(row1,col1)),shape=(162,12467))
testPTRowNorm=preprocessing.normalize(testPT,norm='l1')


tfile = open(datafile1+'TtrainP3tuple.txt')
data = np.loadtxt(tfile,delimiter='	')
row=data[:,0]
print max(row)
col=data[:,1]
print max(col)
d=data[:,2]
TtrainP=spy.sparse.csr_matrix((d,(row,col)),shape=(12467,8659))
#AT=A.transpose()
# normalize according to the row
TtrainPRowNorm=preprocessing.normalize(TtrainP,norm='l1') 


tfile2 = open(datafile1+'trainPA3tuple.txt')
data2 = np.loadtxt(tfile2,delimiter='	')
row=data2[:,0]
col=data2[:,1]
d=data2[:,2]
trainPA=spy.sparse.csr_matrix((d,(row,col)),shape=(8659,12660))
trainPARowNorm=preprocessing.normalize(trainPA,norm='l1')

print 'get the matrix of PTPA'
# resultdata means the final PTPA similarity matrix
#resultdatatemp=np.dot(testPT,TtrainP) #pathcount
#resultdata=np.dot(resultdatatemp,trainPA) #pathcount
resultdatatemp=np.dot(testPTRowNorm,TtrainPRowNorm) #pcrw
resultdata=np.dot(resultdatatemp,trainPARowNorm) #pcrw
# sort according to row
#resulindex=np.argsort(-resultdata.todense(),axis=1)
sizenum=resultdata.shape 
print 'the number of row , column of matrix PTPA'
print sizenum[0]
print sizenum[1]
print 'get the matrix of APA'
#get the matrix of APA
AtrainP=trainPA.transpose()
AtrainPRowNorm=preprocessing.normalize(AtrainP,norm='l1')
#APAresultdata=np.dot(AtrainP,trainPA) #pathcount
APAresultdata=np.dot(AtrainPRowNorm,trainPARowNorm) #pcrw
sizenumber=APAresultdata.shape
print 'the number of row , column of matrix APA'
print sizenumber[0]
print sizenumber[1]
# ..............................................information of test papers........................................
# obtain id2testP dict
testP35=dict()
testP35idlist=list()
id2testP=dict()
testP2id=dict()
testPid_wordid=dict()
testPid_refid=dict()
testPid_venueid=dict()
testPid_citationid=dict()
tfile4 = open(datafile1+'DM_test_paper.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	testP35[t2[0]]=t2[1]
	testP35idlist.append(t2[0])
	id2testP[int(t2[0])]=t2[1]
	testP2id[t2[1]]=int(t2[0])
	testPid_wordid[int(t2[0])]=list()
	testPid_refid[int(t2[0])]=list()
	testPid_citationid[int(t2[0])]=list()
tfile4.close()
print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
print '------------------get the testP_100candAuthor_dict and testP_100candAuthorid_dict-------------'
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(int(t2[1]))
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(authorindex2id[int(t2[1])])
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()
'''
print '------------------get the testP_100candAuthor_array and testP_100candAuthorid_array-------------'
testP_100candAuthor_array=spy.sparse.lil_matrix((162,100))
testP_100candAuthorid_array=spy.sparse.lil_matrix((162,100))
testP_orderAuthor10_array=spy.sparse.lil_matrix((162,10))
for i in range(0,162):
	testP_100candAuthor_array[i,:]=testP_100candAuthor_dict[id2testP[i]]
	testP_100candAuthorid_array[i,:]=testP_100candAuthorid_dict[id2testP[i]]
testP_100candAuthor_array=testP_100candAuthor_array.astype(int)
testP_100candAuthorid_array=testP_100candAuthorid_array.astype(int)
print testP_100candAuthor_array.shape
print testP_100candAuthorid_array.shape
'''

print '------------------get the testP_wordid,-testP_venueid,testP_refenrenceid------------'

inf6 = open(datafile1+"DM_test_p2o_final.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] in wordindex2id:
		testPid_wordid[testP2id[t2[0]]].append(wordindex2id[t2[1]])
	if t2[1] in trainvenue2id:
		testPid_venueid[testP2id[t2[0]]]=trainvenue2id[t2[1]]
	if t2[1] in ALLpaper2id:
		testPid_citationid[testP2id[t2[0]]].append(ALLpaper2id[t2[1]])
		testPid_refid[testP2id[t2[0]]].append(ALLpaper2id[t2[1]])


multiauthor=dict()# author cishu == the num of author's paper
authornumsample=0
multiauthor0=dict()# author cishu == the num of author's paper'0.75
authornumsample0=0
for eachj in author_paperlist:
	for eachk in range(0,len(author_paperlist[eachj])):
		multiauthor[authornumsample]=eachj
		authornumsample=authornumsample+1
	for eachk0 in range(0,int(pow(len(author_paperlist[eachj]),0.75))):
		multiauthor0[authornumsample0]=eachj
		authornumsample0=authornumsample0+1
print authornumsample
print authornumsample0
# input arguments
parser = argparse.ArgumentParser(description='code of embedding method for only 100 candidate authors')
parser.add_argument('--candA_num',type = int, default = 100,help = 'max num of candidate authors for each test paper')
parser.add_argument('--testP_num',type = int, default = 162,help = 'max num of test papers')
#parser.add_argument('--onlyreference_num',type = int, default = 160897,help = 'max num of only reference papers')
parser.add_argument('--word_num',type = int, default = 12467,help = 'max num of words')
parser.add_argument('--venue_num',type = int, default =5,help = 'max num of venue')
#parser.add_argument('--year_num',type = int, default = 60,help = 'max num of train year')
parser.add_argument('--trainP_num',type = int, default = 8659,help = 'max num of train papers')
parser.add_argument('--embed_dim',type = int, default = 128,help = 'embed dimension of author,paper,venue,word,year')
#parser.add_argument('--window',type = int, default = 5,help = 'window size ')
parser.add_argument('--batch_size',type = int, default = 200,help = 'batch size of training ')
parser.add_argument('--learn_rate',type = float, default = 0.00001,help = 'learning rate ')
parser.add_argument('--train_iter_max',type = int, default = 50,help = 'max num of training iteration ')
parser.add_argument('--margin_distance',type = float, default = 2,help = 'margin distance of augmented component ')
parser.add_argument('--coe_reg',type = float, default = 0.001,help = 'coefficient of regularization of task or general-network component ')
#parser.add_argument('--trainP_RefP_num',type = int, default = 1723036,help = 'max num of train papers and only reference papers')
#parser.add_argument('--coe_tradeoff',type = float, default = 1,help = 'tradoff coefficient of task and general-network component ')
args = parser.parse_args()
print (args)
#parameters setting
candA_n=args.candA_num
testP_n=args.testP_num
trainP_n=args.trainP_num
embed_d=args.embed_dim
batch_s=args.batch_size
learn_r=args.learn_rate
iter_max=args.train_iter_max
margin_d=args.margin_distance
c_reg=args.coe_reg
word_n=args.word_num
#year_n=args.year_num
venue_n=args.venue_num
#onlyreference_n=args.onlyreference_num
#trainP_RefP_n=args.trainP_RefP_num
#c_tradeoff=args.coe_tradeoff
#data preparation
#tensor preparation

#based on tasks
p_a_a=tf.placeholder(tf.int32,[None,3])
a_a_aAPA=tf.placeholder(tf.int32,[None,3])
a_a_aAPCPA=tf.placeholder(tf.int32,[None,3])
a_a_aAPWPA=tf.placeholder(tf.int32,[None,3])



author_embed = tf.Variable(tf.random_normal([author_n,embed_d],mean=0,stddev=0.01))
word_embed = tf.Variable(tf.random_normal([word_n,embed_d],mean=0,stddev=0.01))
#year_embed = tf.Variable(tf.random_normal([year_n,embed_d],mean=0,stddev=0.01))
venue_embed = tf.Variable(tf.random_normal([venue_n,embed_d],mean=0,stddev=0.01))
trainP_embed = tf.Variable(tf.random_normal([trainP_n,embed_d],mean=0,stddev=0.01))
#onlyreferenceP_embed = tf.Variable(tf.random_normal([onlyreference_n,embed_d],mean=0,stddev=0.01))
weight = tf.Variable(tf.random_normal([1,3],mean=0.5,stddev=0.01))# the order of weight :word,venue,reference
bi = tf.Variable(tf.random_normal([1,3],mean=0.5,stddev=0.01))# the order of bi: the parameters of general network of path APW,APC,APP
#Mprojectpa=tf.Variable(tf.random_normal([embed_d,embed_d],mean=0,stddev=0.01))

#con=tf.constant(0.5,dtype=np.float32)
testP_emb=spy.sparse.lil_matrix((162,embed_d))
k=3
optP=0
optR=0
optJ=0
optF1=0
optMAP=0
optRMSE=10
optloss=100
optalpha=-1
Loss_task=[]
Loss_APA=[]
Loss_APCPA=[]
Loss_APWPA=[]

'''
#based on P_C_C
batchpa=3.15
batchpw=7.539
batchapa=5.79
#batchapcpa=5215.14
#batchapwpa=2287.10
#apcpa ,apwpa so much, so limite the number of their batches
batchapcpa=10
batchapwpa=8
pa_batch_s=int(batch_s*batchpa)-1
pw_batch_s=int(batch_s*batchpw)-1
'''

#based on P_a_a
batchapa=1.83
#batchapcpa=1650.93
#batchapwpa=724.01

#apcpa ,apwpa so much, so limite the number of their batches
batchapcpa=10
batchapwpa=8

apa_batch_s=int(batch_s*batchapa)-1
apcpa_batch_s=int(batch_s*batchapcpa)-1
apwpa_batch_s=int(batch_s*batchapwpa)-1
'''
batchapa=1.83
batchapw=3.56/NegNum
batchapc=0.46/NegNum
batchapp=0.37/NegNum
apa_batch_s=int(batch_s*batchapa)-1
apc_batch_s=int(batch_s*batchapc)-1
apw_batch_s=int(batch_s*batchapw)-1
app_batch_s=int(batch_s*batchapp)-1
'''
for i in range(batch_s):
#for i in range(pa_batch_s):
	paperid=p_a_a[i][0]
	
	word_idindex=tf.gather(trainPid_wordid,paperid)
	temp1=tf.string_split([word_idindex],delimiter='	')
	#tempv=tf.string_to_number(temp1.values[0],tf.float32)
	Nw=tf.reduce_mean(tf.gather(word_embed,tf.string_to_number(temp1.values,tf.int32)),0)

	venue_idindex=tf.gather(trainPid_venueid,paperid)
	temp1=tf.string_split([venue_idindex],delimiter='	')
	Nv=tf.gather(venue_embed,tf.string_to_number(temp1.values,tf.int32))
	''''
	ref_idindex=tf.gather(trainPid_refid,paperid)
	temp1=tf.string_split([ref_idindex],delimiter='	')
	#tempv=tf.string_to_number(temp1.values[0],tf.float32)
	Nr=tf.reduce_mean(tf.gather(trainP_embed,tf.string_to_number(temp1.values,tf.int32)),0)

	#weight=preprocessing.normalize(weight,norm='max')
	p_e=weight[0,0]*Nw+weight[0,1]*Nv+weight[0,2]*Nr
	'''
	p_e=weight[0,0]*Nw+weight[0,1]*Nv
	#tf.assign(trainP_embed[paperid,:],p_e)
	a_e_pos = tf.gather(author_embed,p_a_a[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,p_a_a[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_1=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(p_e,a_e_neg))-tf.reduce_sum(tf.multiply(p_e,a_e_pos)),tf.zeros([1,1]))
	hing_1=tf.maximum(margin_d-tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_neg),tf.subtract(p_e,a_e_neg)))+\
	tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_pos),tf.subtract(p_e,a_e_pos))),tf.zeros([1,1]))
	Loss_task.append(hing_1)
for i in range(apa_batch_s):
	a_e = tf.gather(author_embed,a_a_aAPA[i][0])
	a_e = tf.reshape(a_e,[1,embed_d])
	a_e_pos = tf.gather(author_embed,a_a_aAPA[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,a_a_aAPA[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_4=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(a_e,a_e_neg))-tf.reduce_sum(tf.multiply(a_e,a_e_pos)),tf.zeros([1,1]))
	hing_4=tf.maximum(margin_d-tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_neg),tf.subtract(a_e,a_e_neg)))+\
	tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_pos),tf.subtract(a_e,a_e_pos))),tf.zeros([1,1]))
	Loss_APA.append(hing_4)
for i in range(apcpa_batch_s):
	a_e = tf.gather(author_embed,a_a_aAPCPA[i][0])
	a_e = tf.reshape(a_e,[1,embed_d])
	a_e_pos = tf.gather(author_embed,a_a_aAPCPA[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,a_a_aAPCPA[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_5=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(a_e,a_e_neg))-tf.reduce_sum(tf.multiply(a_e,a_e_pos)),tf.zeros([1,1]))
	hing_5=tf.maximum(margin_d-tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_neg),tf.subtract(a_e,a_e_neg)))+\
	tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_pos),tf.subtract(a_e,a_e_pos))),tf.zeros([1,1]))
	Loss_APCPA.append(hing_5)
for i in range(apwpa_batch_s):
	a_e = tf.gather(author_embed,a_a_aAPWPA[i][0])
	a_e = tf.reshape(a_e,[1,embed_d])
	a_e_pos = tf.gather(author_embed,a_a_aAPWPA[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,a_a_aAPWPA[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_6=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(a_e,a_e_neg))-tf.reduce_sum(tf.multiply(a_e,a_e_pos)),tf.zeros([1,1]))
	hing_6=tf.maximum(margin_d-tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_neg),tf.subtract(a_e,a_e_neg)))+\
	tf.reduce_sum(tf.multiply(tf.subtract(a_e,a_e_pos),tf.subtract(a_e,a_e_pos))),tf.zeros([1,1]))
	Loss_APWPA.append(hing_6)

X=tf.concat((author_embed,word_embed),0)
X=tf.concat((X,venue_embed),0)
n_rows=tf.cast(tf.shape(X)[0],tf.float32)
X=X-(tf.reduce_mean(X,axis=0))
cov=tf.matmul(X,X,transpose_a=True)/n_rows
Loss_cov=tf.reduce_sum(tf.matrix_set_diag(cov,tf.zeros(embed_d,tf.float32)))

#joint losss
t_v = tf.trainable_variables()
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed),tf.nn.l2_loss(trainP_embed)])
reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed),tf.nn.l2_loss(Mprojectpa)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(v) for v in t_v])
#joint_lossPA=tf.reduce_mean(Loss_task)+c_reg*reg_loss
#joint_loss=tf.reduce_mean(Loss_task)+tf.reduce_mean(Loss_APA)+0.01*tf.reduce_mean(Loss_PW)+0.01*tf.reduce_mean(Loss_PC)+c_reg*reg_loss
#joint_loss=tf.reduce_mean(Loss_task)+tf.reduce_mean(Loss_APA)+tf.reduce_mean(Loss_APCPA)+tf.reduce_mean(Loss_APWPA)+c_reg*reg_loss
for omega in range(len(weigAPWAPC)):
	#joint_loss=weigAPWAPC[omega]*tf.reduce_mean(Loss_task)+(1-weigAPWAPC[omega])*tf.reduce_mean(Loss_APWAPC)+c_reg*reg_loss
	#joint_loss=tf.reduce_mean(Loss_task)+tf.reduce_mean(Loss_APA)+tf.reduce_mean(Loss_APCPA)+tf.reduce_mean(Loss_APWPA)+c_reg*reg_loss
	joint_loss=tf.reduce_mean(Loss_task)+0.3333*(tf.reduce_mean(Loss_APA)+tf.reduce_mean(Loss_APCPA)+tf.reduce_mean(Loss_APWPA))+c_reg*Loss_cov
	optimizer = tf.train.AdamOptimizer(learning_rate=learn_r).minimize(joint_loss)

	#train model
	init = tf.global_variables_initializer()
	saver = tf.train.Saver()
	t1=time.time()
	#with tf.Session() as sess:
	with tf.Session(config = tf.ConfigProto(inter_op_parallelism_threads=2,intra_op_parallelism_threads = 2)) as sess:
	#with tf.Session(config = tf.ConfigProto(log_device_placement=True)) as sess:
		sess.run(init)
		#randomly sample negtive author
		p_a_a_batch=input_tripledata.p_author_author(authorid2index,trainPid_authorindex,author_n,trainP_n,authorindex2id,NegNum)
		#sample negtive author according to author degree
		#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample,multiauthor,authorindex2id,NegNum)
		#sample negtive author according to author degree'0.75
		#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample0,multiauthor0,authorindex2id,NegNum)
		#p_w_w_batch=input_tripledata.p_word_word(wordid2index,trainPid_wordindex,word_n,trainP_n,wordindex2id,NegNum)
		#p_c_c_batch=input_tripledata.p_venue_venue(trainvenueid2index,trainPid_venueindex,venue_n,trainP_n,trainvenue2id,NegNum)
		a_a_aAPA_batch=input_tripledata.a_a_aAPA(authorid2index,authorid_coauthorindex,author_n,authorindex2id,NegNum)
		a_a_aAPCPA_batch=input_tripledata.a_a_aAPCPA(DMapcpa_authorid_authorid,author_n,NegNum)
		a_a_aAPWPA_batch=input_tripledata.a_a_aAPWPA(DMapwpa_authorid_authorid,author_n,NegNum)
		#a_c_cAPC_batch=input_tripledata.a_c_c_cAPC(DMapc_authorid_venueid,author_n,venue_n,NegNum)
		#a_w_wAPW_batch=input_tripledata.a_w_w_wAPW(DMapw_authorid_wordid,author_n,word_n,NegNum)
		#a_p_pAPP_batch=input_tripledata.a_p_pAPP(DMapp_authorid_refid,author_n,trainP_n,NegNum)
		#print len(p_a_a_batch)
		
		'''
		print len(p_a_a_batch)
		print len(p_w_w_batch)
		print len(p_c_c_batch)
		print len(a_a_aAPA_batch)
		print len(a_a_aAPCPA_batch)
		print len(a_a_aAPWPA_batch)
		'''
		mini_batch_n=int(len(p_a_a_batch)/batch_s)
		print 'mini_batch_n:'+str(mini_batch_n)
		#mini_batch_nPC=int(len(p_c_c_batch)/batch_s)
		#print 'mini_batch_nPC:'+str(mini_batch_nPC)
	
		for epoch in range(iter_max):
			print 'epoch:'+str(epoch)
			random.shuffle(p_a_a_batch)
			random.shuffle(a_a_aAPA_batch)
			random.shuffle(a_a_aAPCPA_batch)
			random.shuffle(a_a_aAPWPA_batch)
			'''
			for j in range(mini_batch_n):
				p_a_a_mini_batch = p_a_a_batch[j*batch_s:(j+1)*batch_s]
				feed_dict={p_a_a:p_a_a_mini_batch}
				_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
				#_, loss_v = sess.run([optimizerPA,joint_lossPA],feed_dict)
			p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-batch_s:len(p_a_a_batch)]
			feed_dict={p_a_a:p_a_a_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
			#_, loss_v = sess.run([optimizerPA,joint_lossPA],feed_dict)
			'''
			'''
			for j in range(mini_batch_nPC):
				p_a_a_mini_batch = p_a_a_batch[j*pa_batch_s:(j+1)*pa_batch_s]
				p_w_w_mini_batch = p_w_w_batch[j*pw_batch_s:(j+1)*pw_batch_s]
				p_c_c_mini_batch = p_c_c_batch[j*batch_s:(j+1)*batch_s]
				a_a_a_mini_batch = a_a_aAPA_batch[j*apa_batch_s:(j+1)*apa_batch_s]
				feed_dict={p_a_a:p_a_a_mini_batch,p_w_w:p_w_w_mini_batch,p_c_c:p_c_c_mini_batch,a_a_aAPA:a_a_a_mini_batch}
				_, loss_v = sess.run([optimizer,joint_loss],feed_dict)

			p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-pa_batch_s:len(p_a_a_batch)]
			p_w_w_mini_batch = p_w_w_batch[len(p_w_w_batch)-pw_batch_s:len(p_w_w_batch)]
			p_c_c_mini_batch = p_c_c_batch[len(p_c_c_batch)-batch_s:len(p_c_c_batch)]
			a_a_a_mini_batch = a_a_aAPA_batch[len(a_a_aAPA_batch)-apa_batch_s:len(a_a_aAPA_batch)]
			feed_dict={p_a_a:p_a_a_mini_batch,p_w_w:p_w_w_mini_batch,p_c_c:p_c_c_mini_batch,a_a_aAPA:a_a_a_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
			'''
			for j in range(mini_batch_n):
				p_a_a_mini_batch = p_a_a_batch[j*batch_s:(j+1)*batch_s]
				a_a_aAPA_mini_batch = a_a_aAPA_batch[j*apa_batch_s:(j+1)*apa_batch_s]
				a_a_aAPCPA_mini_batch = a_a_aAPCPA_batch[j*apcpa_batch_s:(j+1)*apcpa_batch_s]
				a_a_aAPWPA_mini_batch = a_a_aAPWPA_batch[j*apwpa_batch_s:(j+1)*apwpa_batch_s]
				feed_dict={p_a_a:p_a_a_mini_batch,a_a_aAPA:a_a_aAPA_mini_batch,a_a_aAPCPA:a_a_aAPCPA_mini_batch,a_a_aAPWPA:a_a_aAPWPA_mini_batch}
				_, loss_v = sess.run([optimizer,joint_loss],feed_dict)

			p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-batch_s:len(p_a_a_batch)]
			a_a_aAPA_mini_batch = a_a_aAPA_batch[len(a_a_aAPA_batch)-apa_batch_s:len(a_a_aAPA_batch)]
			a_a_aAPCPA_mini_batch = a_a_aAPCPA_batch[len(a_a_aAPCPA_batch)-apcpa_batch_s:len(a_a_aAPCPA_batch)]
			a_a_aAPWPA_mini_batch = a_a_aAPWPA_batch[len(a_a_aAPWPA_batch)-apwpa_batch_s:len(a_a_aAPWPA_batch)]
			feed_dict={p_a_a:p_a_a_mini_batch,a_a_aAPA:a_a_aAPA_mini_batch,a_a_aAPCPA:a_a_aAPCPA_mini_batch,a_a_aAPWPA:a_a_aAPWPA_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
			

			author_emb=sess.run(author_embed)
			word_emb=sess.run(word_embed)
			venue_emb=sess.run(venue_embed)
			trainP_emb=sess.run(trainP_embed)
			wei=sess.run(weight)
			#Mprojectpa_emb=sess.run(Mprojectpa)
			for i in range(0,162):
				wordmean=np.mean(word_emb[testPid_wordid[i],:],axis=0)
				venuemean=venue_emb[testPid_venueid[i],:]
				#refmean=np.mean(trainP_emb[testPid_refid[i],:],axis=0)
				#venuemean=np.mean(venue_emb[testPid_venueid[i],:],axis=0)
				#refmean=np.mean(trainpRefp_emb[testPid_citationid[i],:],axis=0)

				testP_emb[i,:]=wei[0][0]*wordmean+wei[0][1]*venuemean
				#project matrix
				#tg=(wei[0][0]*wordmean+wei[0][1]*venuemean).transpose()
				#testP_emb[i,:]=(np.dot(Mprojectpa_emb,tg)).transpose()
			testPAmat=np.dot(testP_emb.todense(),author_emb.transpose())
			for ijk in range(0,len(alphalist)):
				for ii in range(0,NUmtestP):
					#paperid=str(ii)
					GraphneighbDict=dict()
					testPid=testP35idlist[ii]
					testPindex=testP35[testPid]
					tempe=id2testP[ii]
					tempAlist=testP_100candAuthorid_dict[tempe]
					tempAembed=author_emb[tempAlist,:]
					#poduction dot
					#testPmat=testPAmat[ii,tempAlist]
					# Euclidean distance
					#print testP_emb[ii,:].todense()
					#print tempAembed.shape[0]
					temarry=np.square(tempAembed-np.tile(testP_emb[ii,:].todense(),[tempAembed.shape[0],1]))
					aPmultiply=np.sqrt(temarry.sum(axis=1))
					#print aPmultiply
					testPmat=aPmultiply.transpose()
					#print testPmat
					testPmat=np.exp(-testPmat)
					#print testPmat
					testPmatMaxNorm=preprocessing.normalize(testPmat,norm='max')

					# multiply the  weight of PTPA similarity 
					matrixtemp=preprocessing.normalize(resultdata[int(testPid),testP_100candAuthorid_dict[testPindex]],norm='max').todense()
					if np.sum(matrixtemp)==0:
						matrixtemp=np.ones((1,100))
					#print testPmatMaxNorm.shape
					#print matrixtemp.shape
					#print testPmatMaxNorm
					#print matrixtemp
					testPmatMaxNorm=np.multiply(testPmatMaxNorm,matrixtemp)
					testPmatMaxNorm=preprocessing.normalize(testPmatMaxNorm,norm='max')

					r=testPmatMaxNorm>0
					ind=np.where(r)
					#production dot
					AAmat100=np.dot(tempAembed,tempAembed.transpose())
					#Euclidean distance
			
					for hu in range(100):
						Aitemp=np.square(tempAembed-np.tile(tempAembed[hu,:],[100,1]))
						Aitemp2=np.sqrt(Aitemp.sum(axis=1))
						Aitemp3=Aitemp2.transpose()
						AAmat100[hu,:]=Aitemp3
					AAmat100=np.exp(-AAmat100)
					AAmat100RowMax=preprocessing.normalize(AAmat100,norm='max')
					'''
					# besides the diag element is 1, the max value of the left is set to be 1
					leftmaxvalue=0
					for j in range(0,99):
						temvalue=np.max(AAmat100RowMax[j,(j+1):100])
						if temvalue>leftmaxvalue:
							leftmaxvalue=temvalue
					AAmat100RowMax=AAmat100RowMax./leftmaxvalue
					'''
					'''
					# caculate the mean of diag elements
					sumvalue=0
					for j in range(0,99):
						sumvalue=sumvalue+np.sum(AAmat100RowMax[j,(j+1):100])
					meanvalue=sumvalue/4950
					'''
					testPAindex=testP_100candAuthor_dict[tempe]
					# write the P----A part of graph
					for i in range(0,len(ind[1])):
						temptemp=str(testP_100candAuthor_dict[tempe][ind[1][i]])
						if temptemp not in GraphneighbDict:
							GraphneighbDict[temptemp]=dict()
						GraphneighbDict[temptemp][tempe]=beta*testPmatMaxNorm[0,ind[1][i]]
						if tempe not in GraphneighbDict:
							GraphneighbDict[tempe]=dict()
						GraphneighbDict[tempe][temptemp]=beta*testPmatMaxNorm[0,ind[1][i]]
				
					# write the A----A part of graph
					for j in range(0,99):
						#rtemp=AAmat100RowMax[j,j:100]>np.mean(AAmat100RowMax[j,:])
						matrixtempt=preprocessing.normalize(APAresultdata[testP_100candAuthorid_dict[testPindex][j],testP_100candAuthorid_dict[testPindex]],norm='max').todense()
						AAmat100RowMax[j,:]=np.multiply(matrixtempt,AAmat100RowMax[j,:])
						AAmat100RowMax[j,:]=preprocessing.normalize(AAmat100RowMax[j,:],norm='max')
						rtemp=AAmat100RowMax[j,(j+1):100]>0
						#print rtemp.shape
						#print (rtemp.reshape(1,-1)).shape
						rrtemp=rtemp.reshape(1,-1)
						indtt=np.where(rrtemp)
						for ji in range(0,len(indtt[1])):
							tempAA=str(testPAindex[indtt[1][ji]+j+1])
							tempAA1=str(testPAindex[j])
							if tempAA not in GraphneighbDict:
								GraphneighbDict[tempAA]=dict()
							GraphneighbDict[tempAA][tempAA1]=AAmat100RowMax[j,indtt[1][ji]+j+1]
							if tempAA1 not in GraphneighbDict:
								GraphneighbDict[tempAA1]=dict()
							GraphneighbDict[tempAA1][tempAA]=AAmat100RowMax[j,indtt[1][ji]+j+1]
					Densubset=set()
					Densubset.add(testP35[testP35idlist[ii]])
					AddInvestigDict=dict()
					AddInvestigDict[testP35[testP35idlist[ii]]]=1
					RemoveInvestigDict=dict()
					RemoveInvestigDict[testP35[testP35idlist[ii]]]=1

					b1=True
					b2=True
					counter=1
					while(b1 and counter<=Tmax):
						b2=True
						while (b2):
							#print 'Iteration'+str(counter)
							found = False
							for i in GraphneighbDict:
								if i not in AddInvestigDict:
									temp=set()
									temp.add(i)
									#print Densubset|temp
									score=function_score.f_score(Densubset|temp,GraphneighbDict,alphalist[ijk])
									#print optscore
									#print score[0]
									if score[0] > optscore:
										Densubset.add(i)
										optscore=score[0]
										found=True
									AddInvestigDict[i]=1
							if found == False:
								b2=False
								#print 'No additions to Densubset can make improvemens now'
							elif counter<=Tmax:
								AddInvestigDict={}
								for k in Densubset:
									AddInvestigDict[k]=1
			
						found == False
						for j in Densubset:
							if j not in RemoveInvestigDict:
								temp2=set()
								temp2.add(j)
								score=function_score.f_score(Densubset-temp2,GraphneighbDict,alphalist[ijk])
								if score[0] > optscore:
									found=True
									#print 'the number of edges in subset is :  '+str(score[1])
									#print 'the max value of edges weight in subset is :  '+str(score[2])
									#print 'the min value of edges weight in subset is :  '+str(score[3])
									Densubset.remove(j)
									optscore=score[0]
								RemoveInvestigDict[j]=1
								if found == True:
									AddInvestigDict.pop(j)
									break
						if found == False:
							b1=False
							#print 'No removes to Densubset can make improvemens now'
						elif counter<=Tmax:
							RemoveInvestigDict={}
							RemoveInvestigDict[testP35[testP35idlist[ii]]]=1

						counter = counter + 1

					tr=set()
					tr.add(testP35[testP35idlist[ii]])
					PredAuthDict[testP35[testP35idlist[ii]]]=list(Densubset-tr)
					print len(PredAuthDict[testP35[testP35idlist[ii]]])
					optscore=0
					print 'the th test paper:'+str(ii)
			print '---------------get the metric value---------'
		
			evaluresul=PRJF1metric1.evalu(testP_trueA_dict,PredAuthDict)
			#if evaluresul[0]>optP:
			#if evaluresul[1]>optR:
			#if evaluresul[2]>optJ:
			if evaluresul[3]>optF1:
			#if evaluresul[4]>optMAP:
			#if evaluresul[5]<optRMSE:
				optP=evaluresul[0]
				optR=evaluresul[1]
				optJ=evaluresul[2]
				optF1=evaluresul[3]
				optMAP=evaluresul[4]
				optRMSE=evaluresul[5]
				optalpha=alphalist[ijk]
				print 'the current optimal Precision value is :'+str(optP)
				'''
				opt_author_embed=author_embed
				opt_word_embed=word_embed
				opt_venue_embed=venue_embed
				opt_trainP_embed=trainP_embed
				opt_weight=weight
			
				opt_author_embed=sess.run(author_embed)
				opt_word_embed=sess.run(word_embed)
				opt_venue_embed=sess.run(venue_embed)
				opt_trainP_embed=sess.run(trainP_embed)
				opt_weight=sess.run(weight)
				'''
	difomega[weigAPWAPC[omega]]=[optP,optR,optJ,optF1,optMAP,optRMSE]
print 'the optimal P,R,F1,J,MAP:'+str(optP)+', '+str(optR)+', '+str(optF1)+','+str(optJ)+','+str(optMAP)+','+str(optRMSE)+','+str(optalpha)
t9=time.time()
#print 'time of pre-data procession:'+str(t1-t0)
print 'time of iter 1 time :'+str(t9-t0)
print difomega
