#only  task-specific loss
# only reference citation paper 160897,train citation paper 1562139,
# train paper 1562139,test paper 33644, only reference paper 160897, whole paper 1756680
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse
import input_tripledata


datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../EmbeddingGraph/TaskEmbedGraph/'
#datafile2 = '../EmbeddingGraph/GeneralEmbedGraph/'
#datafile2 = '../EmbeddingGraph/CombineEmbedGraph/'

t0=time.time()

# (venue,word,year,reference)index2id(id:int)
ALLpaper2id=dict()
#inf1 = open(datafile1+"id2onlyreference.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	ALLpaper2id[t2[1]]=int(t2[0])+1562139
wordindex2id=dict()

inf1 = open(datafile1+"DM_word.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	wordindex2id[t2[1]]=int(t2[0])
	
#trainyear2id=dict()
#inf1 = open(datafile1+"id2train_year.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	trainyear2id[t2[1]]=int(t2[0])
trainvenue2id=dict()
inf1 = open(datafile1+"DM_venue.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainvenue2id[t2[1]]=int(t2[0])

inf1 = open(datafile1+"DM_trainpaper.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	ALLpaper2id[t2[1]]=int(t2[0])

#obtain authorid2index dictionary and 5 dictionary trainP2word,author,venue,year,citation
authorid2index=dict()
authorindex2id=dict()
inf1 = open(datafile1+"DM_author.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	authorid2index[t2[0]]=t2[1]
	authorindex2id[int(t2[1])]=int(t2[0])
author_n=len(authorid2index)
trainPid_wordindex={}
trainPid_venueindex={}
#trainPid_yearindex={}
#trainPid_allCitationPindex={}
trainPid_authorindex={}
#trainPid_citationOnlyRefindex={}
inf1 = open(datafile1+"DM_trainP_wordindex.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainPid_wordindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_wordindex[t2[0]].append(wordindex2id[t2[i+1]])
inf2 = open(datafile1+"DM_trainP_venueindex.txt","r")
for line in inf2.readlines():
	t2=line.strip().split('	')
	trainPid_venueindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_venueindex[t2[0]].append(trainvenue2id[t2[i+1]])
#inf3 = open("trainPid_yearindex.txt","r")
#for line in inf3.readlines():
#	t2=line.strip().split('	')
#	trainPid_yearindex[t2[0]]=list()
#	if len(t2)>1:
#		for i in range(0,len(t2)-1):
#			trainPid_yearindex[t2[0]].append(trainyear2id[t2[i+1]])
#inf4 = open("trainPid_allCitationPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip().split('	')
##	trainPid_allCitationPindex[t2[0]]=list()
#	if len(t2)>1:
##		for i in range(0,len(t2)-1):
#			trainPid_allCitationPindex[t2[0]].append(ALLpaper2id[t2[i+1]])
inf5 = open(datafile1+"DM_trainP_authorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	trainPid_authorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_authorindex[t2[0]].append(t2[i+1])


print len(trainPid_wordindex)
print len(trainPid_venueindex)
#print len(trainPid_yearindex)
#print len(trainPid_allCitationPindex)
print len(trainPid_authorindex)
#print len(trainPid_citationOnlyRefindex)
trainPid_wordid=[]#[['1	9	7'],['4	5	6'],[]]
trainPid_venueid=[]
#trainPid_yearid=[]
#trainPid_citationTrainPid=[]
trainPid_authorid=[]
#trainPid_citationOnlyRefid=[]
#trainPid_allCitationPid=[]
inf1 = open(datafile1+"DM_notrainP_wordid.txt","r")
for line in inf1.readlines():
	t2=line.strip()
	trainPid_wordid.append(t2)
inf2 = open(datafile1+"DM_notrainP_venueid.txt","r")
for line in inf2.readlines():
	t2=line.strip()
	trainPid_venueid.append(t2)
#inf3 = open(datafile1+"trainPid_yearid.txt","r")
#for line in inf3.readlines():
#	t2=line.strip()
#	trainPid_yearid.append(t2[2:])
#inf4 = open("trainPid_citationtrainPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip()
#	trainPid_citationTrainPid.append(t2[2:])
inf5 = open(datafile1+"DM_notrainP_authorid.txt","r")
for line in inf5.readlines():
	t2=line.strip()
	trainPid_authorid.append(t2)
#inf51 = open("trainPid_onlyreferenceid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_citationOnlyRefid.append(t2[2:])

#inf51 = open("trainPid_allCitationPid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_allCitationPid.append(t2[2:])
# the pre-data of sampling the negtive author according to author degree
author_paperlist=dict()
inf6 = open(datafile1+"DM_train_p2a.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] not in author_paperlist:
		author_paperlist[t2[1]]=list()
	author_paperlist[t2[1]].append(t2[0])
print len(author_paperlist)
multiauthor=dict()# author cishu == the num of author's paper
authornumsample=0
multiauthor0=dict()# author cishu == the num of author's paper'0.75
authornumsample0=0
for eachj in author_paperlist:
	for eachk in range(0,len(author_paperlist[eachj])):
		multiauthor[authornumsample]=eachj
		authornumsample=authornumsample+1
	for eachk0 in range(0,int(pow(len(author_paperlist[eachj]),0.75))):
		multiauthor0[authornumsample0]=eachj
		authornumsample0=authornumsample0+1
print authornumsample
print authornumsample0
# input arguments
parser = argparse.ArgumentParser(description='code of embedding method for only 100 candidate authors')
parser.add_argument('--candA_num',type = int, default = 100,help = 'max num of candidate authors for each test paper')
parser.add_argument('--testP_num',type = int, default = 162,help = 'max num of test papers')
#parser.add_argument('--onlyreference_num',type = int, default = 160897,help = 'max num of only reference papers')
parser.add_argument('--word_num',type = int, default = 12467,help = 'max num of words')
parser.add_argument('--venue_num',type = int, default =5,help = 'max num of venue')
#parser.add_argument('--year_num',type = int, default = 60,help = 'max num of train year')
parser.add_argument('--trainP_num',type = int, default = 8659,help = 'max num of train papers')
parser.add_argument('--embed_dim',type = int, default = 128,help = 'embed dimension of author,paper,venue,word,year')
#parser.add_argument('--window',type = int, default = 5,help = 'window size ')
parser.add_argument('--batch_size',type = int, default = 200,help = 'batch size of training ')
parser.add_argument('--learn_rate',type = float, default = 0.001,help = 'learning rate ')
parser.add_argument('--train_iter_max',type = int, default = 50,help = 'max num of training iteration ')
parser.add_argument('--margin_distance',type = float, default = 1,help = 'margin distance of augmented component ')
parser.add_argument('--coe_reg',type = float, default = 0.001,help = 'coefficient of regularization of task or general-network component ')
#parser.add_argument('--trainP_RefP_num',type = int, default = 1723036,help = 'max num of train papers and only reference papers')
#parser.add_argument('--coe_tradeoff',type = float, default = 1,help = 'tradoff coefficient of task and general-network component ')
args = parser.parse_args()
print (args)
#parameters setting
candA_n=args.candA_num
testP_n=args.testP_num
trainP_n=args.trainP_num
embed_d=args.embed_dim
batch_s=args.batch_size
learn_r=args.learn_rate
iter_max=args.train_iter_max
margin_d=args.margin_distance
c_reg=args.coe_reg
word_n=args.word_num
#year_n=args.year_num
venue_n=args.venue_num
#onlyreference_n=args.onlyreference_num
#trainP_RefP_n=args.trainP_RefP_num
#c_tradeoff=args.coe_tradeoff
#data preparation
#tensor preparation
p_a_a=tf.placeholder(tf.int32,[None,3])
print type(p_a_a)
author_embed = tf.Variable(tf.random_normal([author_n,embed_d],mean=0,stddev=0.01))
word_embed = tf.Variable(tf.random_normal([word_n,embed_d],mean=0,stddev=0.01))
#year_embed = tf.Variable(tf.random_normal([year_n,embed_d],mean=0,stddev=0.01))
venue_embed = tf.Variable(tf.random_normal([venue_n,embed_d],mean=0,stddev=0.01))
trainP_embed = tf.Variable(tf.random_normal([trainP_n,embed_d],mean=0,stddev=0.01))
#onlyreferenceP_embed = tf.Variable(tf.random_normal([onlyreference_n,embed_d],mean=0,stddev=0.01))
weight = tf.Variable(tf.random_normal([1,2],mean=0.5,stddev=0.1))# the order of weight :word,venue
print type(author_embed)

#con=tf.constant(0.5,dtype=np.float32)

optloss=100
Loss_task=[]
for i in range(batch_s):
	paperid=p_a_a[i][0]

	word_idindex=tf.gather(trainPid_wordid,paperid)
	temp1=tf.string_split([word_idindex],delimiter='	')
	#tempv=tf.string_to_number(temp1.values[0],tf.float32)
	Nw=tf.reduce_mean(tf.gather(word_embed,tf.string_to_number(temp1.values,tf.int32)),0)

	venue_idindex=tf.gather(trainPid_venueid,paperid)
	temp1=tf.string_split([venue_idindex],delimiter='	')
	Nv=tf.gather(venue_embed,tf.string_to_number(temp1.values,tf.int32))

	#weight=preprocessing.normalize(weight,norm='max')
	p_e=weight[0,0]*Nw+weight[0,1]*Nv
	tf.assign(trainP_embed[paperid,:],p_e)
	a_e_pos = tf.gather(author_embed,p_a_a[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,p_a_a[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	hing_1=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(p_e,a_e_neg))-tf.reduce_sum(tf.multiply(p_e,a_e_pos)),tf.zeros([1,1]))
	#hing_1=tf.maximum(margin_d-tf.sqrt(tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_neg),tf.subtract(p_e,a_e_neg))))+\
	#tf.sqrt(tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_pos),tf.subtract(p_e,a_e_pos)))),tf.zeros([1,1]))
	Loss_task.append(hing_1)
	
#joint losss
t_v = tf.trainable_variables()
reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed),tf.nn.l2_loss(trainP_embed)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(v) for v in t_v])
joint_loss=tf.reduce_mean(Loss_task)+c_reg*reg_loss

#optimizer
optimizer = tf.train.AdamOptimizer(learning_rate=learn_r).minimize(joint_loss)

#train model
init = tf.global_variables_initializer()
saver = tf.train.Saver()
t1=time.time()
#with tf.Session() as sess:
with tf.Session(config = tf.ConfigProto(inter_op_parallelism_threads=2,intra_op_parallelism_threads = 2)) as sess:
#with tf.Session(config = tf.ConfigProto(log_device_placement=True)) as sess:
	sess.run(init)
	opt_author_embed=author_embed
	opt_word_embed=word_embed
	opt_venue_embed=venue_embed
	#opt_trainP_embed=trainP_embed
	opt_weight=weight
	#randomly sample negtive author
	p_a_a_batch=input_tripledata.p_author_author(authorid2index,trainPid_authorindex,author_n,trainP_n,authorindex2id)
	#sample negtive author according to author degree
	#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample,multiauthor,authorindex2id)
	#sample negtive author according to author degree'0.75
	#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample0,multiauthor0,authorindex2id)
	mini_batch_n=int(len(p_a_a_batch)/batch_s)
	print 'mini_batch_n:'+str(mini_batch_n)
	for epoch in range(iter_max):
		print 'epoch:'+str(epoch)
		sumloss=0.0
		random.shuffle(p_a_a_batch)
		for j in range(mini_batch_n):
			p_a_a_mini_batch = p_a_a_batch[j*batch_s:(j+1)*batch_s]
			feed_dict={p_a_a:p_a_a_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)

			sumloss=sumloss+loss_v
		if sumloss/mini_batch_n < optloss :
			optloss=sumloss/mini_batch_n
			print 'the current optimal value is :'+str(optloss)
			opt_author_embed=author_embed
			opt_word_embed=word_embed
			opt_venue_embed=venue_embed
			#opt_trainP_embed=trainP_embed
			opt_weight=weight
			'''
			opt_author_embed=sess.run(author_embed)
			opt_word_embed=sess.run(word_embed)
			opt_venue_embed=sess.run(venue_embed)
			#opt_trainP_embed=sess.run(trainP_embed)
			opt_weight=sess.run(weight)
			'''
			#if j==0:
			#	print 'loss value is:'+str(loss_v)
	
		'''
		p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-batch_s:len(p_a_a_batch)]
		feed_dict={p_a_a:p_a_a_mini_batch}
		_, loss_v = sess.run([optimizer,joint_loss],feed_dict)
		'''

	a_e=sess.run(opt_author_embed)
	w_e=sess.run(opt_word_embed)
	#y_e=sess.run(year_embed)
	v_e=sess.run(opt_venue_embed)
	#trainp_e=sess.run(opt_trainP_embed)	
	#onlyref_e=sess.run(onlyreferenceP_embed)
	weig_e=sess.run(opt_weight)
	
	np.savetxt(datafile2+'author_embedresult.txt',a_e)
	np.savetxt(datafile2+'word_embedresult.txt',w_e)
	#np.savetxt(datafile2+'year_embedresult.txt',y_e)
	np.savetxt(datafile2+'venue_embedresult.txt',v_e)
	#np.savetxt(datafile2+'trainp_embedresult.txt',trainp_e)
	#np.savetxt('onlyreferenceP_embedresult.txt',onlyref_e)
	np.savetxt(datafile2+'weight_result.txt',weig_e)
	print a_e.shape
	print w_e.shape
	#print y_e.shape
	print v_e.shape
	#print trainp_e.shape
	#print onlyref_e.shape
	print weig_e.shape
	print 'weight value is :'
	print weig_e

t9=time.time()
print 'time of pre-data procession:'+str(t1-t0)
print 'time of iter 1 time :'+str(t9-t1)

