#only  task-specific loss   +   tune parameter with metric measures in test data
# only reference citation paper 160897,train citation paper 1562139,
# train paper 1562139,test paper 33644, only reference paper 160897, whole paper 1756680
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse
import input_tripledata
import PRJF1metric1
import function_score


datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../EmbeddingGraph/TaskEmbedGraph/'
#datafile2 = '../EmbeddingGraph/GeneralEmbedGraph/'
#datafile2 = '../EmbeddingGraph/CombineEmbedGraph/'

t0=time.time()
# (venue,word,year,reference)index2id(id:int)
ALLpaper2id=dict()
#inf1 = open(datafile1+"id2onlyreference.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	ALLpaper2id[t2[1]]=int(t2[0])+1562139
wordindex2id=dict()
inf1 = open(datafile1+"DM_word.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	wordindex2id[t2[1]]=int(t2[0])
#trainyear2id=dict()
#inf1 = open(datafile1+"id2train_year.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	trainyear2id[t2[1]]=int(t2[0])
trainvenue2id=dict()
inf1 = open(datafile1+"DM_venue.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainvenue2id[t2[1]]=int(t2[0])

inf1 = open(datafile1+"DM_trainpaper.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	ALLpaper2id[t2[1]]=int(t2[0])

#obtain authorid2index dictionary and 5 dictionary trainP2word,author,venue,year,citation
authorid2index=dict()
authorindex2id=dict()
author2id=dict()
inf1 = open(datafile1+"DM_author.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	authorid2index[t2[0]]=t2[1]
	authorindex2id[int(t2[1])]=int(t2[0])
	author2id[t2[1]]=int(t2[0])
author_n=len(authorid2index)
trainPid_wordindex={}
trainPid_venueindex={}
#trainPid_yearindex={}
#trainPid_allCitationPindex={}
trainPid_authorindex={}
#trainPid_citationOnlyRefindex={}
inf1 = open(datafile1+"DM_trainP_wordindex.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainPid_wordindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_wordindex[t2[0]].append(wordindex2id[t2[i+1]])
inf2 = open(datafile1+"DM_trainP_venueindex.txt","r")
for line in inf2.readlines():
	t2=line.strip().split('	')
	trainPid_venueindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_venueindex[t2[0]].append(trainvenue2id[t2[i+1]])
#inf3 = open("trainPid_yearindex.txt","r")
#for line in inf3.readlines():
#	t2=line.strip().split('	')
#	trainPid_yearindex[t2[0]]=list()
#	if len(t2)>1:
#		for i in range(0,len(t2)-1):
#			trainPid_yearindex[t2[0]].append(trainyear2id[t2[i+1]])
#inf4 = open("trainPid_allCitationPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip().split('	')
##	trainPid_allCitationPindex[t2[0]]=list()
#	if len(t2)>1:
##		for i in range(0,len(t2)-1):
#			trainPid_allCitationPindex[t2[0]].append(ALLpaper2id[t2[i+1]])
inf5 = open(datafile1+"DM_trainP_authorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	trainPid_authorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			trainPid_authorindex[t2[0]].append(t2[i+1])


print len(trainPid_wordindex)
print len(trainPid_venueindex)
#print len(trainPid_yearindex)
#print len(trainPid_allCitationPindex)
print len(trainPid_authorindex)
#print len(trainPid_citationOnlyRefindex)
trainPid_wordid=[]#[['1	9	7'],['4	5	6'],[]]
trainPid_venueid=[]
#trainPid_yearid=[]
#trainPid_citationTrainPid=[]
trainPid_authorid=[]
#trainPid_citationOnlyRefid=[]
#trainPid_allCitationPid=[]
inf1 = open(datafile1+"DM_notrainP_wordid.txt","r")
for line in inf1.readlines():
	t2=line.strip()
	trainPid_wordid.append(t2)
inf2 = open(datafile1+"DM_notrainP_venueid.txt","r")
for line in inf2.readlines():
	t2=line.strip()
	trainPid_venueid.append(t2)
#inf3 = open(datafile1+"trainPid_yearid.txt","r")
#for line in inf3.readlines():
#	t2=line.strip()
#	trainPid_yearid.append(t2[2:])
#inf4 = open("trainPid_citationtrainPid.txt","r")
#for line in inf4.readlines():
#	t2=line.strip()
#	trainPid_citationTrainPid.append(t2[2:])
inf5 = open(datafile1+"DM_notrainP_authorid.txt","r")
for line in inf5.readlines():
	t2=line.strip()
	trainPid_authorid.append(t2)
#inf51 = open("trainPid_onlyreferenceid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_citationOnlyRefid.append(t2[2:])

#inf51 = open("trainPid_allCitationPid.txt","r")
#for line in inf51.readlines():
#	t2=line.strip()
#	trainPid_allCitationPid.append(t2[2:])
# the pre-data of sampling the negtive author according to author degree
author_paperlist=dict()
inf6 = open(datafile1+"DM_train_p2a.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] not in author_paperlist:
		author_paperlist[t2[1]]=list()
	author_paperlist[t2[1]].append(t2[0])
print len(author_paperlist)

# ..............................................information of test papers........................................

infile2 = open(datafile1+'DM_test_paper.txt','r')
testP35=dict()
testP35idlist=list()
for line in infile2.readlines():
	t2=line.strip().split('	')
	testP35[t2[0]]=t2[1]
	testP35idlist.append(t2[0])
print len(testP35)
print len(testP35idlist)
id2testP=dict()
testP2id=dict()
testPid_wordid=dict()
testPid_venueid=dict()
testPid_citationid=dict()
tfile4 = open(datafile1+'DM_test_paper.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	id2testP[int(t2[0])]=t2[1]
	testP2id[t2[1]]=int(t2[0])
	testPid_wordid[int(t2[0])]=list()
	testPid_citationid[int(t2[0])]=list()
tfile4.close()
inf6 = open(datafile1+"DM_test_p2o_final.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] in wordindex2id:
		testPid_wordid[testP2id[t2[0]]].append(wordindex2id[t2[1]])
	if t2[1] in trainvenue2id:
		testPid_venueid[testP2id[t2[0]]]=trainvenue2id[t2[1]]
	if t2[1] in ALLpaper2id:
		testPid_citationid[testP2id[t2[0]]].append(ALLpaper2id[t2[1]])
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(int(t2[1]))
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(author2id[t2[1]])
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()
authorid_coauthorindex={}
inf5 = open(datafile1+"DM_authorid_coauthorindex.txt","r")
for line in inf5.readlines():
	t2=line.strip().split('	')
	authorid_coauthorindex[t2[0]]=list()
	if len(t2)>1:
		for i in range(0,len(t2)-1):
			authorid_coauthorindex[t2[0]].append(t2[i+1])
beta=0.7
alpha=3 # parameter of density function 
optscore=0
#Tmax=50
Tmax=1
NUmtestP=162 # 1 test paper
#NUmtestP=33644
PredAuthDict=dict()
NegNum=2

print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
DiffAlphaMeanResul=dict()



multiauthor=dict()# author cishu == the num of author's paper
authornumsample=0
multiauthor0=dict()# author cishu == the num of author's paper'0.75
authornumsample0=0
for eachj in author_paperlist:
	for eachk in range(0,len(author_paperlist[eachj])):
		multiauthor[authornumsample]=eachj
		authornumsample=authornumsample+1
	for eachk0 in range(0,int(pow(len(author_paperlist[eachj]),0.75))):
		multiauthor0[authornumsample0]=eachj
		authornumsample0=authornumsample0+1
print authornumsample
print authornumsample0
# input arguments
parser = argparse.ArgumentParser(description='code of embedding method for only 100 candidate authors')
parser.add_argument('--candA_num',type = int, default = 100,help = 'max num of candidate authors for each test paper')
parser.add_argument('--testP_num',type = int, default = 162,help = 'max num of test papers')
#parser.add_argument('--onlyreference_num',type = int, default = 160897,help = 'max num of only reference papers')
parser.add_argument('--word_num',type = int, default = 12467,help = 'max num of words')
parser.add_argument('--venue_num',type = int, default =5,help = 'max num of venue')
#parser.add_argument('--year_num',type = int, default = 60,help = 'max num of train year')
parser.add_argument('--trainP_num',type = int, default = 8659,help = 'max num of train papers')
parser.add_argument('--embed_dim',type = int, default = 128,help = 'embed dimension of author,paper,venue,word,year')
#parser.add_argument('--window',type = int, default = 5,help = 'window size ')
parser.add_argument('--batch_size',type = int, default = 200,help = 'batch size of training ')
parser.add_argument('--learn_rate',type = float, default = 0.00001,help = 'learning rate ')
parser.add_argument('--train_iter_max',type = int, default = 50,help = 'max num of training iteration ')
parser.add_argument('--margin_distance',type = float, default = 1,help = 'margin distance of augmented component ')
parser.add_argument('--coe_reg',type = float, default = 0.001,help = 'coefficient of regularization of task or general-network component ')
#parser.add_argument('--trainP_RefP_num',type = int, default = 1723036,help = 'max num of train papers and only reference papers')
#parser.add_argument('--coe_tradeoff',type = float, default = 1,help = 'tradoff coefficient of task and general-network component ')
args = parser.parse_args()
print (args)
#parameters setting
candA_n=args.candA_num
testP_n=args.testP_num
trainP_n=args.trainP_num
embed_d=args.embed_dim
batch_s=args.batch_size
learn_r=args.learn_rate
iter_max=args.train_iter_max
margin_d=args.margin_distance
c_reg=args.coe_reg
word_n=args.word_num
#year_n=args.year_num
venue_n=args.venue_num
#onlyreference_n=args.onlyreference_num
#trainP_RefP_n=args.trainP_RefP_num
#c_tradeoff=args.coe_tradeoff
#data preparation
#tensor preparation
p_a_a=tf.placeholder(tf.int32,[None,3])
print type(p_a_a)
author_embed = tf.Variable(tf.random_normal([author_n,embed_d],mean=0,stddev=0.01))
word_embed = tf.Variable(tf.random_normal([word_n,embed_d],mean=0,stddev=0.01))
#year_embed = tf.Variable(tf.random_normal([year_n,embed_d],mean=0,stddev=0.01))
venue_embed = tf.Variable(tf.random_normal([venue_n,embed_d],mean=0,stddev=0.01))
trainP_embed = tf.Variable(tf.random_normal([trainP_n,embed_d],mean=0,stddev=0.01))
#onlyreferenceP_embed = tf.Variable(tf.random_normal([onlyreference_n,embed_d],mean=0,stddev=0.01))
weight = tf.Variable(tf.random_normal([1,2],mean=0.5,stddev=0.1))# the order of weight :word,venue
print type(author_embed)

#con=tf.constant(0.5,dtype=np.float32)
testP_emb=spy.sparse.lil_matrix((162,embed_d))
#k=2
optP=0
optR=0
optJ=0
optF1=0
optMAP=0
optRMSE=10
optalpha=-1
optloss=100
Loss_task=[]
for i in range(batch_s):
	paperid=p_a_a[i][0]

	word_idindex=tf.gather(trainPid_wordid,paperid)
	temp1=tf.string_split([word_idindex],delimiter='	')
	#tempv=tf.string_to_number(temp1.values[0],tf.float32)
	Nw=tf.reduce_mean(tf.gather(word_embed,tf.string_to_number(temp1.values,tf.int32)),0)

	venue_idindex=tf.gather(trainPid_venueid,paperid)
	temp1=tf.string_split([venue_idindex],delimiter='	')
	Nv=tf.gather(venue_embed,tf.string_to_number(temp1.values,tf.int32))

	#weight=preprocessing.normalize(weight,norm='max')
	p_e=weight[0,0]*Nw+weight[0,1]*Nv
	#tf.assign(trainP_embed[paperid,:],p_e)
	a_e_pos = tf.gather(author_embed,p_a_a[i][1])
	a_e_pos = tf.reshape(a_e_pos,[1,embed_d])
	a_e_neg = tf.gather(author_embed,p_a_a[i][2])
	a_e_neg = tf.reshape(a_e_neg,[1,embed_d])
	#hing_1=tf.maximum(margin_d+tf.reduce_sum(tf.multiply(p_e,a_e_neg))-tf.reduce_sum(tf.multiply(p_e,a_e_pos)),tf.zeros([1,1]))
	hing_1=tf.maximum(margin_d-tf.sqrt(tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_neg),tf.subtract(p_e,a_e_neg))))+\
	tf.sqrt(tf.reduce_sum(tf.multiply(tf.subtract(p_e,a_e_pos),tf.subtract(p_e,a_e_pos)))),tf.zeros([1,1]))
	Loss_task.append(hing_1)
	
#joint losss
t_v = tf.trainable_variables()
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed),tf.nn.l2_loss(trainP_embed)])
reg_loss= tf.reduce_sum([tf.nn.l2_loss(author_embed), tf.nn.l2_loss(word_embed),tf.nn.l2_loss(venue_embed)])
#reg_loss= tf.reduce_sum([tf.nn.l2_loss(v) for v in t_v])
joint_loss=tf.reduce_mean(Loss_task)+c_reg*reg_loss

#optimizer
optimizer = tf.train.AdamOptimizer(learning_rate=learn_r).minimize(joint_loss)

#train model
init = tf.global_variables_initializer()
saver = tf.train.Saver()
t1=time.time()
#with tf.Session() as sess:
with tf.Session(config = tf.ConfigProto(inter_op_parallelism_threads=2,intra_op_parallelism_threads = 2)) as sess:
#with tf.Session(config = tf.ConfigProto(log_device_placement=True)) as sess:
	sess.run(init)
	opt_author_embed=author_embed
	opt_word_embed=word_embed
	opt_venue_embed=venue_embed
	#opt_trainP_embed=trainP_embed
	opt_weight=weight
	#randomly sample negtive author
	p_a_a_batch=input_tripledata.p_author_author(authorid2index,trainPid_authorindex,author_n,trainP_n,authorindex2id,NegNum)
	#sample negtive author according to author degree
	#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample,multiauthor,authorindex2id,NegNum)
	#sample negtive author according to author degree'0.75
	#p_a_a_batch=input_tripledata.p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample0,multiauthor0,authorindex2id,NegNum)
	mini_batch_n=int(len(p_a_a_batch)/batch_s)
	print 'mini_batch_n:'+str(mini_batch_n)
	for epoch in range(iter_max):
		print 'epoch:'+str(epoch)
		sumloss=0.0
		random.shuffle(p_a_a_batch)
		for j in range(mini_batch_n):
			p_a_a_mini_batch = p_a_a_batch[j*batch_s:(j+1)*batch_s]
			feed_dict={p_a_a:p_a_a_mini_batch}
			_, loss_v = sess.run([optimizer,joint_loss],feed_dict)

		p_a_a_mini_batch = p_a_a_batch[len(p_a_a_batch)-batch_s:len(p_a_a_batch)]
		feed_dict={p_a_a:p_a_a_mini_batch}
		_, loss_v = sess.run([optimizer,joint_loss],feed_dict)

		author_emb=sess.run(author_embed)
		word_emb=sess.run(word_embed)
		venue_emb=sess.run(venue_embed)
		#trainP_emb=sess.run(trainP_embed)
		wei=sess.run(weight)
		for i in range(0,162):
			wordmean=np.mean(word_emb[testPid_wordid[i],:],axis=0)
			venuemean=venue_emb[testPid_venueid[i],:]
			#refmean=np.mean(trainpRefp_emb[testPid_citationid[i],:],axis=0)
			testP_emb[i,:]=wei[0][0]*wordmean+wei[0][1]*venuemean
		testPAmat=np.dot(testP_emb.todense(),author_emb.transpose())
		for ijk in range(2,alpha):
			for ii in range(0,NUmtestP):
				#paperid=str(ii)
				GraphneighbDict=dict()
				tempe=id2testP[ii]
				tempAlist=testP_100candAuthorid_dict[tempe]
				tempAembed=author_emb[tempAlist,:]
				#poduction dot
				#testPmat=testPAmat[ii,tempAlist]
				# Euclidean distance
				temarry=np.square(tempAembed-np.tile(testP_emb[ii,:].todense(),[tempAembed.shape[0],1]))
				aPmultiply=np.sqrt(temarry.sum(axis=1))
				testPmat=aPmultiply.transpose()
				
				testPmat=np.exp(-testPmat)
				testPmatMaxNorm=preprocessing.normalize(testPmat,norm='max')
				#production dot
				AAmat100=np.dot(tempAembed,tempAembed.transpose())
				#Euclidean distance
			
				for hu in range(100):
					Aitemp=np.square(tempAembed-np.tile(tempAembed[hu,:],[100,1]))
					Aitemp2=np.sqrt(Aitemp.sum(axis=1))
					Aitemp3=Aitemp2.transpose()
					AAmat100[hu,:]=Aitemp3
				AAmat100=np.exp(-AAmat100)
				AAmat100RowMax=preprocessing.normalize(AAmat100,norm='max')
				'''
				# besides the diag element is 1, the max value of the left is set to be 1
				leftmaxvalue=0
				for j in range(0,99):
					temvalue=np.max(AAmat100RowMax[j,(j+1):100])
					if temvalue>leftmaxvalue:
						leftmaxvalue=temvalue
				AAmat100RowMax=AAmat100RowMax./leftmaxvalue
				'''
				# caculate the mean of diag elements
				sumvalue=0
				for j in range(0,99):
					sumvalue=sumvalue+np.sum(AAmat100RowMax[j,(j+1):100])
				meanvalue=sumvalue/4950
				testPAindex=testP_100candAuthor_dict[tempe]
				# write the P----A part of graph
				for i in range(0,100):
					temptemp=str(testP_100candAuthor_dict[tempe][i])
					if temptemp not in GraphneighbDict:
						GraphneighbDict[temptemp]=dict()
					GraphneighbDict[temptemp][tempe]=beta*testPmatMaxNorm[0,i]
					if tempe not in GraphneighbDict:
						GraphneighbDict[tempe]=dict()
					GraphneighbDict[tempe][temptemp]=beta*testPmatMaxNorm[0,i]
				
				# write the A----A part of graph
				for j in range(0,100):
					#rtemp=AAmat100RowMax[j,j:100]>np.mean(AAmat100RowMax[j,:])
					rtemp=AAmat100RowMax[j,(j+1):100]>meanvalue
					#print rtemp.shape
					#print (rtemp.reshape(1,-1)).shape
					rrtemp=rtemp.reshape(1,-1)
					indtt=np.where(rrtemp)
					for ji in range(0,len(indtt[1])):
						tempAA=str(testPAindex[indtt[1][ji]+j+1])
						tempAA1=str(testPAindex[j])
						if tempAA not in GraphneighbDict:
							GraphneighbDict[tempAA]=dict()
						GraphneighbDict[tempAA][tempAA1]=AAmat100RowMax[j,indtt[1][ji]+j+1]
						if tempAA1 not in GraphneighbDict:
							GraphneighbDict[tempAA1]=dict()
						GraphneighbDict[tempAA1][tempAA]=AAmat100RowMax[j,indtt[1][ji]+j+1]
				Densubset=set()
				Densubset.add(testP35[testP35idlist[ii]])
				AddInvestigDict=dict()
				AddInvestigDict[testP35[testP35idlist[ii]]]=1
				RemoveInvestigDict=dict()
				RemoveInvestigDict[testP35[testP35idlist[ii]]]=1

				b1=True
				b2=True
				counter=1
				while(b1 and counter<=Tmax):
					b2=True
					while (b2):
						#print 'Iteration'+str(counter)
						found = False
						for i in GraphneighbDict:
							if i not in AddInvestigDict:
								temp=set()
								temp.add(i)
								#print Densubset|temp
								score=function_score.f_score(Densubset|temp,GraphneighbDict,ijk)
								#print optscore
								#print score[0]
								if score[0] > optscore:
									Densubset.add(i)
									optscore=score[0]
									found=True
								AddInvestigDict[i]=1
						if found == False:
							b2=False
							#print 'No additions to Densubset can make improvemens now'
						elif counter<=Tmax:
							AddInvestigDict={}
							for k in Densubset:
								AddInvestigDict[k]=1
			
					found == False
					for j in Densubset:
						if j not in RemoveInvestigDict:
							temp2=set()
							temp2.add(j)
							score=function_score.f_score(Densubset-temp2,GraphneighbDict,ijk)
							if score[0] > optscore:
								found=True
								#print 'the number of edges in subset is :  '+str(score[1])
								#print 'the max value of edges weight in subset is :  '+str(score[2])
								#print 'the min value of edges weight in subset is :  '+str(score[3])
								Densubset.remove(j)
								optscore=score[0]
							RemoveInvestigDict[j]=1
							if found == True:
								AddInvestigDict.pop(j)
								break
					if found == False:
						b1=False
						#print 'No removes to Densubset can make improvemens now'
					elif counter<=Tmax:
						RemoveInvestigDict={}
						RemoveInvestigDict[testP35[testP35idlist[ii]]]=1

					counter = counter + 1

				tr=set()
				tr.add(testP35[testP35idlist[ii]])
				PredAuthDict[testP35[testP35idlist[ii]]]=list(Densubset-tr)
				print len(PredAuthDict[testP35[testP35idlist[ii]]])
				optscore=0
				print 'the th test paper:'+str(ii)
	
			print '---------------get the metric value---------'
			evaluresul=PRJF1metric1.evalu(testP_trueA_dict,PredAuthDict)
			#if evaluresul[0]>optP:
			#if evaluresul[1]>optR:
			#if evaluresul[2]>optJ:
			if evaluresul[3]>optF1:
			#if evaluresul[4]>optMAP:
			#if evaluresul[5]<optRMSE:
				optP=evaluresul[0]
				optR=evaluresul[1]
				optJ=evaluresul[2]
				optF1=evaluresul[3]
				optMAP=evaluresul[4]
				optRMSE=evaluresul[5]
				optalpha=ijk
				print 'the current optimal Precision value is :'+str(optP)
				'''
				opt_author_embed=author_embed
				opt_word_embed=word_embed
				opt_venue_embed=venue_embed
				opt_trainP_embed=trainP_embed
				opt_weight=weight
			
				opt_author_embed=sess.run(author_embed)
				opt_word_embed=sess.run(word_embed)
				opt_venue_embed=sess.run(venue_embed)
				opt_trainP_embed=sess.run(trainP_embed)
				opt_weight=sess.run(weight)
			'''
	print 'the optimal P,R,F1,J,MAP,optalpha:'+str(optP)+', '+str(optR)+', '+str(optF1)+','+str(optJ)+','+str(optMAP)+','+str(optRMSE)+','+str(optalpha)

t9=time.time()
print 'time of pre-data procession:'+str(t1-t0)
print 'time of iter 1 time :'+str(t9-t1)

