import numpy as np
import function_score
import time
import PRJF1metric1
# files (GraphTestPid and GraphAPA) are seperated

datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../100candMDSubgraph/'
#infile2 = open(datafile1+'testPid_Pindex_authornum35.txt','r')
infile2 = open(datafile1+'DM_test_paper.txt','r')
testP35=dict()
testP35idlist=list()
for line in infile2.readlines():
	t2=line.strip().split('	')
	testP35[t2[0]]=t2[1]
	testP35idlist.append(t2[0])
print len(testP35)
print len(testP35idlist)


#alpha=5 # parameter of density function 
alpha=10  # from 10 to 1
optscore=0
#Tmax=50
Tmax=1
NUmtestP=162 # 1 test paper
#NUmtestP=163 # all 16401 test papers
PredAuthDict=dict()

print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
DiffAlphaMeanResul=dict()
t0=time.time()
for ijk in range(alpha,0,-1):
	t1=time.time()
	for ii in range(0,NUmtestP):
		paperid=str(ii) # the graph corresponding to the test paper
		GraphneighbDict=dict()
		#print testP35[testP35idlist[ii]]
		infile1 = open(datafile2+"100candA_GraphTestPid"+testP35[testP35idlist[ii]]+".txt","r")
		#infile1 = open("100candA_APTPAGraphTestPid"+testP35[testP35idlist[ii]]+".txt","r")
		for line in infile1.readlines():
			t2=line.strip().split('	')
			if t2[0] not in GraphneighbDict:
				GraphneighbDict[t2[0]]=dict()
			GraphneighbDict[t2[0]][t2[1]]=t2[2]
			if t2[1] not in GraphneighbDict:
				GraphneighbDict[t2[1]]=dict()
			GraphneighbDict[t2[1]][t2[0]]=t2[2]
		infile1.close()
		#print GraphneighbDict.keys()
		Densubset=set()
		Densubset.add(testP35[testP35idlist[ii]])
		AddInvestigDict=dict()
		AddInvestigDict[testP35[testP35idlist[ii]]]=1
		RemoveInvestigDict=dict()
		RemoveInvestigDict[testP35[testP35idlist[ii]]]=1

		b1=True
		b2=True
		counter=1
		while(b1 and counter<=Tmax):
			b2=True
			while (b2):
				#print 'Iteration'+str(counter)
				found = False
				for i in GraphneighbDict:
					if i not in AddInvestigDict:
						temp=set()
						temp.add(i)
						#print Densubset|temp
						score=function_score.f_score(Densubset|temp,GraphneighbDict,ijk)
						#print optscore
						#print score[0]
						if score[0] > optscore:
							Densubset.add(i)
							#print 'fffffffffffffffffffffffffff'
							#print 'Vertex'+' '+str(i)+' '+'improves when added from'+' '+str(optscore)+' '+'to'+' '+str(score[0])
							#print 'the number of edges in subset is :  '+str(score[1])
							#print 'the max value of edges weight in subset is :  '+str(score[2])
							#print 'the min value of edges weight in subset is :  '+str(score[3])
							optscore=score[0]
							found=True
						AddInvestigDict[i]=1
				if found == False:
					b2=False
					#print 'No additions to Densubset can make improvemens now'
				elif counter<=Tmax:
					AddInvestigDict={}
					for k in Densubset:
						AddInvestigDict[k]=1
			
			found == False
			for j in Densubset:
				if j not in RemoveInvestigDict:
					temp2=set()
					temp2.add(j)
					score=function_score.f_score(Densubset-temp2,GraphneighbDict,ijk)
					if score[0] > optscore:
						found=True
						#print 'Vertex'+' '+str(j)+' '+'improves when removed from'+' '+str(optscore)+' '+'to'+' '+str(score[0])
						#print 'the number of edges in subset is :  '+str(score[1])
						#print 'the max value of edges weight in subset is :  '+str(score[2])
						#print 'the min value of edges weight in subset is :  '+str(score[3])
						Densubset.remove(j)
						optscore=score[0]
					RemoveInvestigDict[j]=1
					if found == True:
						AddInvestigDict.pop(j)
						break
			if found == False:
				b1=False
				#print 'No removes to Densubset can make improvemens now'
			elif counter<=Tmax:
				RemoveInvestigDict={}
				RemoveInvestigDict[testP35[testP35idlist[ii]]]=1

			counter = counter + 1

		tr=set()
		tr.add(testP35[testP35idlist[ii]])
		PredAuthDict[testP35[testP35idlist[ii]]]=list(Densubset-tr)
		print len(PredAuthDict[testP35[testP35idlist[ii]]])
		optscore=0
		print 'the th test paper:'+str(ii)
	#print PredAuthDict
	t2=time.time()
	print 'time of circle :'+str(t2-t1)
	
	print '---------------get the metric value---------'
	evaluresul=PRJF1metric1.evalu(testP_trueA_dict,PredAuthDict)
	
	# obtain the mean dict of different alpha,the order of mean:P,R,J,F1,MAP
	DiffAlphaMeanResul[ijk]=evaluresul

print DiffAlphaMeanResul
t9=time.time()
print 'time of circle :'+str(t9-t0)
