#only  task-specific loss
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse


t1=time.time()
datafile = '../../../DBLP_v8/'
datafile1 = '../'

## randomly sample the negtive author
def p_author_author(authorid2index,trainPid_authorindex,author_n,trainP_n,authorindex2id,NegNum):
	p_a_a_triple=[]
	for j in range(0,trainP_n):
		tek=trainPid_authorindex[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				a_neg=random.randint(0,author_n-1)
				while authorid2index[str(a_neg)] in tek:
					a_neg=random.randint(0,author_n-1)
				triple=[j,authorindex2id[int(tek[k])],a_neg]
				p_a_a_triple.append(triple)
	return p_a_a_triple

# sample the negtive author according to author degree or author degree'0.75

def p_author_author_degree(trainPid_authorindex,trainP_n,authornumsample,multiauthor,authorindex2id,NegNum):
	p_a_a_triple=[]
	for j in range(0,trainP_n):
		for k in range(0,len(trainPid_authorindex[str(j)])):
			for l in range(NegNum):
				a_neg=random.randint(0,authornumsample-1)
				while multiauthor[a_neg] in trainPid_authorindex[str(j)]:
					a_neg=random.randint(0,authornumsample-1)
				triple=[j,authorindex2id[int(trainPid_authorindex[str(j)][k])],authorindex2id[int(multiauthor[a_neg])]]
				p_a_a_triple.append(triple)
	return p_a_a_triple

def p_word_word(wordid2index,trainPid_wordindex,word_n,trainP_n,wordindex2id,NegNum):
	p_w_w_triple=[]
	for j in range(0,trainP_n):
		tek=trainPid_wordindex[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				w_neg=random.randint(0,word_n-1)
				while wordid2index[str(w_neg)] in tek:
					w_neg=random.randint(0,word_n-1)
				#print trainPid_wordindex[str(j)][k]
				triple=[j,wordindex2id[tek[k]],w_neg]
				p_w_w_triple.append(triple)
	return p_w_w_triple
def p_venue_venue(trainvenueid2index,trainPid_venueindex,venue_n,trainP_n,trainvenue2id,NegNum):
	p_c_c_triple=[]
	for j in range(0,trainP_n):
		tek=trainPid_venueindex[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				c_neg=random.randint(0,venue_n-1)
				while trainvenueid2index[str(c_neg)] in tek:
					c_neg=random.randint(0,venue_n-1)
				triple=[j,trainvenue2id[tek[k]],c_neg]
				p_c_c_triple.append(triple)
	return p_c_c_triple
def a_a_aAPA(authorid2index,authorid_coauthorindex,author_n,authorindex2id,NegNum):
	a_a_aAPA_triple=[]
	for j in range(0,author_n):
		tek=authorid_coauthorindex[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				a_neg=random.randint(0,author_n-1)
				while authorid2index[str(a_neg)] in tek:
					a_neg=random.randint(0,author_n-1)
				triple=[j,authorindex2id[int(tek[k])],a_neg]
				a_a_aAPA_triple.append(triple)
	return a_a_aAPA_triple

def a_a_aAPCPA(DMapcpa_authorid_authorid,author_n,NegNum):
	a_a_aAPCPA_triple=[]
	for j in range(0,author_n):
		tek=DMapcpa_authorid_authorid[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				a_neg=random.randint(0,author_n-1)
				while str(a_neg) in tek:
					a_neg=random.randint(0,author_n-1)
				triple=[j,int(tek[k]),a_neg]
				a_a_aAPCPA_triple.append(triple)
	return a_a_aAPCPA_triple

def a_a_aAPWPA(DMapwpa_authorid_authorid,author_n,NegNum):
	a_a_aAPWPA_triple=[]
	for j in range(0,author_n):
		tek=DMapwpa_authorid_authorid[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				a_neg=random.randint(0,author_n-1)
				while str(a_neg) in tek:
					a_neg=random.randint(0,author_n-1)
				triple=[j,int(tek[k]),a_neg]
				a_a_aAPWPA_triple.append(triple)
	return a_a_aAPWPA_triple

def a_c_cAPC(DMapc_authorid_venueid,author_n,venue_n,NegNum):
	a_c_cAPC_triple=[]
	for j in range(0,author_n):
		tek=DMapc_authorid_venueid[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				c_neg=random.randint(0,venue_n-1)
				while str(c_neg) in tek:
					c_neg=random.randint(0,venue_n-1)
				triple=[j,int(tek[k]),c_neg]
				a_c_cAPC_triple.append(triple)
	return a_c_cAPC_triple
#2 Neg a_c_c_c 
def a_c_c_cAPC(DMapc_authorid_venueid,author_n,venue_n,NegNum):
	a_c_c_cAPC_triple=[]
	for j in range(0,author_n):
		tek=DMapc_authorid_venueid[str(j)]
		for k in range(0,len(tek)):
			triple=[j,int(tek[k])]
			for l in range(NegNum):
				c_neg=random.randint(0,venue_n-1)
				while str(c_neg) in tek:
					c_neg=random.randint(0,venue_n-1)
				triple.append(c_neg)
			a_c_c_cAPC_triple.append(triple)
	return a_c_c_cAPC_triple

def a_w_wAPW(DMapw_authorid_wordid,author_n,word_n,NegNum):
	a_w_wAPW_triple=[]
	for j in range(0,author_n):
		tek=DMapw_authorid_wordid[str(j)]
		for k in range(0,len(tek)):
			for l in range(NegNum):
				w_neg=random.randint(0,word_n-1)
				while str(w_neg) in tek:
					w_neg=random.randint(0,word_n-1)
				triple=[j,int(tek[k]),w_neg]
				a_w_wAPW_triple.append(triple)
	return a_w_wAPW_triple
#2 Neg a_w_w_w
def a_w_w_wAPW(DMapw_authorid_wordid,author_n,word_n,NegNum):
	a_w_w_wAPW_triple=[]
	for j in range(0,author_n):
		tek=DMapw_authorid_wordid[str(j)]
		for k in range(0,len(tek)):
			triple=[j,int(tek[k])]
			for l in range(NegNum):
				w_neg=random.randint(0,word_n-1)
				while str(w_neg) in tek:
					w_neg=random.randint(0,word_n-1)
				triple.append(w_neg)
			a_w_w_wAPW_triple.append(triple)
	return a_w_w_wAPW_triple
def a_p_pAPP(DMapp_authorid_refid,author_n,trainP_n,NegNum):
	a_p_pAPP_triple=[]
	for j in range(0,author_n):
		tek=DMapp_authorid_refid[str(j)]
		for k in range(0,len(tek)):
			triple=[j,int(tek[k])]
			for l in range(NegNum):
				p_neg=random.randint(0,trainP_n-1)
				while str(p_neg) in tek:
					p_neg=random.randint(0,trainP_n-1)
				triple.append(p_neg)
			a_p_pAPP_triple.append(triple)
	return a_p_pAPP_triple
def p_author_author_gene(authorid2index,trainPid_authorindex,author_n,trainP_n,authorindex2id,NegNum):
	p_a_a_triple=[]
	for j in range(0,trainP_n):
		tek=trainPid_authorindex[str(j)]
		for k in range(0,len(tek)):
			triple=[j,authorindex2id[int(tek[k])]]
			for l in range(NegNum):
				a_neg=random.randint(0,author_n-1)
				while authorid2index[str(a_neg)] in tek:
					a_neg=random.randint(0,author_n-1)
				triple.append(a_neg)
			p_a_a_triple.append(triple)
	return p_a_a_triple
def p_a_aPWPA(DMpwpa_paperid_authorid,trainP_n,author_n,NegNum):
	p_a_a_triple=[]
	for j in range(0,trainP_n):
		tek=DMpwpa_paperid_authorid[str(j)]
		for k in range(0,len(tek)):
			triple=[j,int(tek[k])]
			for l in range(NegNum):
				a_neg=random.randint(0,author_n-1)
				while str(a_neg) in tek:
					a_neg=random.randint(0,author_n-1)
				triple.append(a_neg)
			p_a_a_triple.append(triple)
	return p_a_a_triple
'''
# 1:path A-P OR A-P-P  2:path: A-P-C     3:path:A-P-W
def path_i_j_k(ALLpaper2id,trainvenue2id,wordindex2id,author_n,author_paperlist,authorid_paperlist,authorindex2id,K,ALLpaperid2index,\
	trainP_n,trainAtrainC3tuplefile,venue_n,A2Vid,trainAtrainW3tuplefile,word_n,A2Wid):
	path_i_j_tiple=[]
	# get the triple of A-P path
	for i in range(0,author_n):
		l=authorid_paperlist[i]
		for j in range(0,len(l)):
			for k in range(0,K):
				p_neg=random.randint(0,trainP_n-1)
				while ALLpaperid2index[p_neg] in l:
					p_neg=random.randint(0,trainP_n-1)
				triple=[1,i,ALLpaper2id[l[j]],p_neg]
				path_i_j_tiple.append(triple)
	# get the triple of A-P-C path
	for line in trainAtrainC3tuplefile.readlines():
		t2=line.strip().split('	')
		for ig in range(0,int(t2[2])):
			for ik in range(0,K):
				c_neg=random.randint(0,venue_n-1)
				while str(c_neg) in A2Vid[t2[0]]:
					c_neg=random.randint(0,venue_n-1)
				triple=[2,int(t2[0]),int(t2[1]),c_neg]
				path_i_j_tiple.append(triple)
	# get the triple of A-P-W path
	for line in trainAtrainW3tuplefile.readlines():
		t2=line.strip().split('	')
		for ig in range(0,int(t2[2])):
			for ik in range(0,K):
				w_neg=random.randint(0,word_n-1)
				while str(w_neg) in A2Wid[t2[0]]:
					w_neg=random.randint(0,word_n-1)
				triple=[3,int(t2[0]),int(t2[1]),w_neg]
				path_i_j_tiple.append(triple)
	return path_i_j_tiple
			
def path_i_j_k_degree():
	path_i_j_tiple=[]

	return path_i_j_tiple
'''

